
package modelo;

import java.io.Serializable;
import java.util.Observable;
import javax.persistence.*;


// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.2704856F-2132-6276-42C2-EA61476B539D]
// </editor-fold>
/**
 *
 * Clase Actor, identifica a un <b>autor</b> y hace una <b>descripción</b> sobre él.
 */
@Entity
@Table (name="Actor")
public class Actor extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.4105E8E0-8601-8404-42AB-98F7DCCEEF43]
    // </editor-fold>
    /**
     * Con esta variable identificamos el nombre.
     */
    @Column (name="name actor")
    private String nombre;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.36DAC889-BB81-121D-E612-D261B8C83DA2]
    // </editor-fold>
    /**
     * Con esta variable hacemos una descripción detallada del actor.
     */
    @Column (name="description")
    private String descripcion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.E58D5B3C-159E-2680-60E3-E88621F1552B]
    // </editor-fold>
    /**
     * Constructor de la clase Autor
     */
    public Actor () {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E2DD9EB8-7B6B-52AF-1CF2-DF9636DFBC40]
    // </editor-fold>
    /**
     * Metodo que permite devolver la descripción de un actor.
     * @return la descripción.
     */
    public String getDescripcion () {
        return descripcion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.B7FDC942-D04D-A359-B713-3130F5C4806B]
    // </editor-fold>
    /**
     * Metodo que inserta la descripción de un autor.
     * @param val es el string que se le pasa para que inserte la descripción.
     */
    public void setDescripcion (String val) {
        this.descripcion = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1F15EF19-B79C-2D0C-4ED2-6FF66D5789EF]
    // </editor-fold>
    /**
     * Metodo que permite devolver el nombre de un actor.
     * @return el nombre.
     */
    public String getNombre () {
        return nombre;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.2D7BEECF-2D87-BA50-6DCA-D516687A1232]
    // </editor-fold>
    /**
     * Metodo que inserta el nombre de un autor.
     * @param val es el string que se le pasa para que inserte el nombre.
     */
    public void setNombre (String val) {
        this.nombre = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve solo la parte cadena del identificador
     * @return la cadena id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que inserta solo la parte cadena del identificador
     * @param la cadena id a insertar
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Metodo que devuelve solo la parte número del identificador
     * @return el entero id
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que inserta solo la parte número del identificador
     * @param el entero id a insertar
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve el identificador completo
     * @return el identificador
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que inserta el identificador completo
     * @param ident identificador completo a insertar
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object 
     */
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }
}

