package modelo;

import java.io.File;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Observable;
import javax.persistence.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.DOMImplementation;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Text;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.3366EE0E-3D03-1E28-AA77-F447FC3A3000]
// </editor-fold>
/**
 * Clase DocumentoReq, esta clase es donde se van a almacenar todos los arrays de todas las clases.
 */
@Entity
@Table (name="Documento de requisitos")
public class DocumentoReq extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    
    /**
     * Con esta variable identificamos el nombre del documento
     */
    @Column (name="name document")
    private String nombre;
    /**
     * Con esta variable identificamos el creador del documento
     */
    @Column (name="creator")
    private String creador;
    /**
     * Con esta variable identificamos la fecha en que fue creado el documento
     */
    @Column (name="date doc")
    private String fecha;
    /**
     * Con esta variable identificamos el comentario del documento
     */
    @Column (name="comment")
    private String comentario;
    /**
     * Con esta variable identificamos para quien es el documento
     */
    @Column (name="ready to")
    private String preparado;
    /**
     * Constructor de la clase DocumentoReq
     */
    public DocumentoReq() {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.7B1A1219-3F3A-5451-125C-EFCAF68CEA01]
    // </editor-fold>
    /**
     * Con esta variable identificamos el array de casos de uso
     */
    @OneToMany
    private ArrayList<CasodeUso> mCasodeUso = new ArrayList();

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.A8E93265-D427-036B-BB30-0EB7EDA8B690]
    // </editor-fold>
    /**
     * Con esta variable identificamos el array de requisitos funcionales
     */
    @OneToMany
    private ArrayList<RequisitoFuncional> mRequisitoFuncional = new ArrayList();

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.BB9F6D90-C658-AAD7-9705-0C7165C99570]
    // </editor-fold>
    /**
     * Con esta variable identificamos el array de requisitos de restricción
     */
    @OneToMany
    private ArrayList<RequisitoRestriccion> mRequisitoRestriccion = new ArrayList();

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.6DAE70F0-FDF0-1245-D54A-3CC931614247]
    // </editor-fold>
    /**
     * Con esta variable identificamos el array de requisitos no funcionales
     */
    @OneToMany
    private ArrayList<RequisitoNoFuncional> mRequisitoNoFuncional = new ArrayList();

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.81A2F6DD-DE90-4943-8909-EB624BCFF83E]
    // </editor-fold>
    /**
     * Con esta variable identificamos el array de requisitos de información
     */
    @OneToMany
    private ArrayList<RequisitoInformacion> mRequisitoInformacion = new ArrayList();
    /**
     * Con esta variable identificamos el array de actores
     */
    @OneToMany
    private ArrayList<Actor> mActor = new ArrayList();
    /**
     * Con esta variable identificamos el array de objetivos
     */
    @OneToMany
    private ArrayList<Objetivo> mObjetivo = new ArrayList();
    /**
     * Con esta variable identificamos el array de participantes
     */
    @OneToMany
    private ArrayList<Participante> mParticipante = new ArrayList();
    /**
     * Con esta variable identificamos el array de reuniones
     */
    @OneToMany
    private ArrayList<Reunion> mReunion = new ArrayList();
    /**
     * Con esta variable identificamos el array de parrafos
     */
    @OneToMany
    private ArrayList<Parrafo> mParrafo = new ArrayList();
    /**
     * Con esta variable identificamos el array de ficheros graficos
     */
    @OneToMany
    private ArrayList<FicheroGrafico> mFicheroGrafico = new ArrayList();
    /**
     * Con esta variable identificamos el array de secciones
     */
    @OneToMany
    private ArrayList<Seccion> mSeccion = new ArrayList();
    /**
     * Con esta variable identificamos el array de matrices de rastreabilidad
     */
    @OneToMany
    private ArrayList<MatrizRastreabilidad> mMatrizRastreabilidad = new ArrayList();
    /**
     * Con esta variable identificamos el array de organización
     */
    @OneToMany
    private ArrayList<Organizacion> mOrganizacion = new ArrayList();
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.25C0A09E-7665-F069-5A31-52C0F11381E8]
    // </editor-fold>

    /**
     * Metodo que permite devolver el array de parrafos
     * @return mParrafo array a devolver
     */
    public ArrayList<Parrafo> getParrafo() {
        return mParrafo;

    }
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.CB5CB17D-0AFE-D25C-64C5-CD74B5E48681]
    // </editor-fold> 

    /**
     * Metodo que permite devolver el array de casos de uso
     * @return mCasodeUso array a devolver
     */
    public ArrayList<CasodeUso> getCasodeUso() {
        return mCasodeUso;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.DFF87A80-1105-434D-5E8A-0F47BB2D84E2]
    // </editor-fold>

    /**
     * Metodo que permite insertar el array de casos de uso
     * @param val array a insertar
     */
    public void setCasodeUso(ArrayList<CasodeUso> val) {
        this.mCasodeUso = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que permite insertar el array de parrafos
     * @param val array a insertar
     */
    public void setParrafo(ArrayList<Parrafo> val) {
        this.mParrafo = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que permite devolver el array de ficheros graficos
     * @return mFicheroGrafico array a devolver
     */
    public ArrayList<FicheroGrafico> getFicheroGrafico() {
        return mFicheroGrafico;
    }

    /**
     * Metodo que permite insertar el array de ficheros graficos
     * @param val array a insertar
     */
    public void setFicheroGrafico(ArrayList<FicheroGrafico> val) {
        this.mFicheroGrafico = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que permite devolver el array de secciones
     * @return mSeccion array a devolver
     */
    public ArrayList<Seccion> getSeccion() {
        return mSeccion;
    }

    /**
     * Metodo que permite insertar el array de secciones
     * @param val array a insertar
     */
    public void setSeccion(ArrayList<Seccion> val) {
        this.mSeccion = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que permite insertar el array de organizaciones
     * @param val array a insertar
     */
    public void setOrganizacion(ArrayList<Organizacion> val) {
        this.mOrganizacion = val;
        this.setChanged();
        this.notifyObservers();
    }

     /**
     * Metodo que permite devolver el array de organización
     * @return mOrganización array a devolver
     */
    public ArrayList<Organizacion> getOrganizacion() { 
        return mOrganizacion;
    }

    /**
     * Metodo que permite devolver el array de matrices de rastreabilidad
     * @return mMatrizRastreabilidad array a devolver
     */
    public ArrayList<MatrizRastreabilidad> getMatrizRastreabilidad() {
        return mMatrizRastreabilidad;
    }

    /**
     * Metodo que permite insertar el array de matrices de rastreabilidad
     * @param val array a insertar
     */
    public void setMatrizRastreabilidad(ArrayList<MatrizRastreabilidad> val) {
        this.mMatrizRastreabilidad = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que permite devolver el array de requisitos funcionales
     * @return mRequisitoFuncional array a devolver
     */
    public ArrayList<RequisitoFuncional> getRequisitoFuncional() {
        return mRequisitoFuncional;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,regenBody=yes,id=DCE.8C147AFC-6E9C-F5DF-A091-6AD442A5B8AB]
    // </editor-fold>
    /**
     * Metodo que permite insertar el array de requisitos funcionales
     * @param val array a insertar
     */
    public void setRequisitoFuncional(ArrayList<RequisitoFuncional> val) {
        this.mRequisitoFuncional = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,regenBody=yes,id=DCE.9C2E062B-FF8C-D2A8-7706-7B4366CF8C57]
    // </editor-fold>
    /**
     * Metodo que permite devolver el array de requisitos de información
     * @return mRequisitoInformacion array a devolver
     */
    public ArrayList<RequisitoInformacion> getRequisitoInformacion() {
        return mRequisitoInformacion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,regenBody=yes,id=DCE.5DF491E3-6DD3-06E5-E871-FF95289B4048]
    // </editor-fold>
    /**
     * Metodo que permite insertar el array de requisitos de información
     * @param val array a insertar
     */
    public void setRequisitoInformacion(ArrayList<RequisitoInformacion> val) {
        this.mRequisitoInformacion = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,regenBody=yes,id=DCE.1403D5C5-3935-4EAE-C311-22AA7439ABD7]
    // </editor-fold>
    /**
     * Metodo que permite devolver el array de requisitos no funcionales
     * @return mRequisitoNoFuncional array a devolver
     */
    public ArrayList<RequisitoNoFuncional> getRequisitoNoFuncional() {
        return mRequisitoNoFuncional;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,regenBody=yes,id=DCE.76A7795B-885D-B861-696C-7D0123E57858]
    // </editor-fold>
    /**
     * Metodo que permite insertar el array de requisitos no funcionales
     * @param val array a insertar
     */
    public void setRequisitoNoFuncional(ArrayList<RequisitoNoFuncional> val) {
        this.mRequisitoNoFuncional = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,regenBody=yes,id=DCE.22C8D822-BB25-C711-BF0C-E94B2A129BD4]
    // </editor-fold>
    /**
     * Metodo que permite devolver el array de requisitos de restricción
     * @return mRequisitoRestriccion array a devolver
     */
    public ArrayList<RequisitoRestriccion> getRequisitoRestriccion() {
        return mRequisitoRestriccion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,regenBody=yes,id=DCE.ABD1AADE-3B0E-EAE5-CED9-3013DB3D3E2C]
    // </editor-fold>
    /**
     * Metodo que permite insertar el array de requisitos de restricción
     * @param val array a insertar
     */
    public void setRequisitoRestriccion(ArrayList<RequisitoRestriccion> val) {
        this.mRequisitoRestriccion = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que permite devolver el array de actores
     * @return mActor array a devolver
     */
    public ArrayList<Actor> getActor() {
        return mActor;
    }

    /**
     * Metodo que permite insertar el array de actores
     * @param val array a insertar
     */
    public void setActor(ArrayList<Actor> val) {
        this.mActor = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que permite devolver el array de objetivos
     * @return mObjetivo array a devolver
     */
    public ArrayList<Objetivo> getObjetivo() {
        return mObjetivo;
    }

    /**
     * Metodo que permite insertar el array de objetivos
     * @param val array a insertar
     */
    public void setObjetivo(ArrayList<Objetivo> val) {
        this.mObjetivo = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que permite devolver el array de participantes
     * @return mParticipante array a devolver
     */
    public ArrayList<Participante> getParticipante() {
        return mParticipante;
    }

    /**
     * Metodo que permite insertar el array de participantes
     * @param val array a insertar
     */
    public void setParticipante(ArrayList<Participante> val) {
        this.mParticipante = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que permite devolver el array de reuniones
     * @return mReunion array a devolver
     */
    public ArrayList<Reunion> getReunion() {
        return mReunion;
    }

    /**
     * Metodo que permite insertar el array de reuniones
     * @param val array a insertar
     */
    public void setReunion(ArrayList<Reunion> val) {
        this.mReunion = val;
        this.setChanged();
        this.notifyObservers();
    }
    private ArrayList<Integer> lIdentCU = new ArrayList();
    private ArrayList<Integer> lIdentSE = new ArrayList();
    private ArrayList<Integer> lIdentPRR = new ArrayList();
    private ArrayList<Integer> lIdentFI = new ArrayList();
    private ArrayList<Integer> lIdentOR = new ArrayList();
    private ArrayList<Integer> lIdentPA = new ArrayList();
    private ArrayList<Integer> lIdentRE = new ArrayList();
    private ArrayList<Integer> lIdentRR = new ArrayList();
    private ArrayList<Integer> lIdentRI = new ArrayList();
    private ArrayList<Integer> lIdentRF = new ArrayList();
    private ArrayList<Integer> lIdentRNF = new ArrayList();
    private ArrayList<Integer> lIdentAC = new ArrayList();
    private ArrayList<Integer> lIdentOB = new ArrayList();
    private ArrayList<Integer> lIdentMR = new ArrayList();

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.2EA7A31C-EA23-DCB3-2D72-EF9A9069C18B]
    // </editor-fold>
    /**
     * Metodo para insertar un caso de uso
     * @param Id
     * @param nombreCU
     * @param esAbstracto
     * @param eventoActivacion
     * @param frecuencia
     * @param unidadFrecuencia
     * @param precondicion
     * @param postcondicion
     * @param estabilidad
     * @param importancia
     * @param estado
     * @param urgencia
     * @return devuelve el caso de uso modificado con los parametros pasados por referencia
     */
    public CasodeUso nuevoCU(int Id, String nombreCU, boolean esAbstracto, String eventoActivacion, int frecuencia, String unidadFrecuencia, String precondicion, String postcondicion, String estabilidad, String importancia, String estado, String urgencia) {

        //// Creo la instancia
        CasodeUso auxCU = new CasodeUso();
        //// Asigno los valores a los atributos
        auxCU.setId("CU");
        auxCU.setId_n(Id);
        auxCU.setIdent(auxCU.getId()+String.valueOf(Id));
        auxCU.setNombre(nombreCU);
        auxCU.setEsAbstracto(esAbstracto);
        auxCU.setEventoActivacion(eventoActivacion);
        auxCU.setFrecuencia(frecuencia);
        auxCU.setUnidadFrecuencia(unidadFrecuencia);
        auxCU.setPrecondicion(precondicion);
        auxCU.setPostcondicion(postcondicion);
        auxCU.setEstabilidad(estabilidad);
        auxCU.setEstadodeDesarrollo(estado);
        auxCU.setUrgencia(urgencia);
        auxCU.setImportancia(importancia);
        //// Enlazo el CasodeUso a la lista de CU que tiene el documento
        this.getCasodeUso().add(auxCU);
        //persist(auxCU);
        return auxCU;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.10ED29B6-5428-1AC4-2C86-C37573A9CDBB]
    // </editor-fold>
    /**
     * Metodo para insertar un requisito funcional
     * @param Id
     * @param nombre
     * @param descripcion
     * @param importancia
     * @param urgencia
     * @param estado
     * @param estabilidad
     * @return devuelve un requisito funcional modificado con los parametros pasados por referencia
     */
    public RequisitoFuncional nuevoRF(int Id, String nombre, String descripcion, String importancia, String urgencia, String estado, String estabilidad, ArrayList<String> mDestino, ArrayList<String> mOrigen) {
        //// Creo la instancia
        RequisitoFuncional auxRF = new RequisitoFuncional();
        //// Asigno los valores a los atributos
        auxRF.setId("RF");
        auxRF.setId_n(Id);
        auxRF.setIdent(auxRF.getId()+String.valueOf(Id));
        auxRF.setNombre(nombre);
        auxRF.setDescripcion(descripcion);
        auxRF.setImportancia(importancia);
        auxRF.setUrgencia(urgencia);
        auxRF.setEstado(estado);
        auxRF.setEstabilidad(estabilidad);
        auxRF.setMDestino(mDestino);
        auxRF.setMOrigen(mOrigen);
        //// Enlazo el CasodeUso a la lista de CU que tiene el documento
        this.getRequisitoFuncional().add(auxRF);
        //persist(auxRF);
        return auxRF;
    }


    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.3092630F-85EB-5692-09B6-A6F2DE931A07]
    // </editor-fold>
    /**
     * Metodo para insertar un requisito de restricción
     * @param Id
     * @param nombre
     * @param descripcion
     * @param importancia
     * @param urgencia
     * @param estado
     * @param estabilidad
     * @return devuelve un requisito de restricción modificado con los parametros pasados por referencia
     */
    public RequisitoRestriccion nuevoRes(int Id, String nombre, String descripcion, String importancia, String urgencia, String estado, String estabilidad, ArrayList<String> mDestino, ArrayList<String> mOrigen) {
        //// Creo la instancia
        RequisitoRestriccion auxRes = new RequisitoRestriccion();
        //// Asigno los valores a los atributos
        auxRes.setId("RRE");
        auxRes.setId_n(Id);
        auxRes.setIdent(auxRes.getId()+String.valueOf(Id));
        auxRes.setNombre(nombre);
        auxRes.setDescripcion(descripcion);
        auxRes.setImportancia(importancia);
        auxRes.setUrgencia(urgencia);
        auxRes.setEstado(estado);
        auxRes.setEstabilidad(estabilidad);
        auxRes.setMDestino(mDestino);
        auxRes.setMOrigen(mOrigen);
        //// Enlazo el CasodeUso a la lista de CU que tiene el documento
        this.getRequisitoRestriccion().add(auxRes);
        //persist(auxRes);
        return auxRes;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.1957F206-387E-7824-5ADA-540A6800F594]
    // </editor-fold>
    /**
     * Metodo para insertar un requisito no funcional
     * @param Id
     * @param nombre
     * @param sistema
     * @param importancia
     * @param urgencia
     * @param estado
     * @param estabilidad
     * @return devuelve un requisito no funcional modificado con los parametros pasados por referencia
     */
    public RequisitoNoFuncional nuevoNRF(int Id, String nombre, String sistema, String importancia, String urgencia, String estado, String estabilidad, ArrayList<String> mDestino, ArrayList<String> mOrigen) {
        //// Creo la instancia
        RequisitoNoFuncional auxRNF = new RequisitoNoFuncional();
        //// Asigno los valores a los atributos
        auxRNF.setId("RNF");
        auxRNF.setId_n(Id);
        auxRNF.setIdent(auxRNF.getId()+String.valueOf(Id));
        auxRNF.setNombre(nombre);
        auxRNF.setDescripcion(sistema);
        auxRNF.setImportancia(importancia);
        auxRNF.setUrgencia(urgencia);
        auxRNF.setEstado(estado);
        auxRNF.setEstabilidad(estabilidad);
        auxRNF.setMDestino(mDestino);
        auxRNF.setMOrigen(mOrigen);
        //// Enlazo el CasodeUso a la lista de CU que tiene el documento
        this.getRequisitoNoFuncional().add(auxRNF);
        //persist(auxRNF);
        return auxRNF;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.863F355C-B7B3-3F4D-5314-E8331744B18B]
    // </editor-fold>
    /**
     * Metodo para insertar un requisito de información
     * @param Id
     * @param Nombre
     * @param concepto
     * @param valorMax
     * @param UnidadTMax
     * @param valorMe
     * @param UnidadTMe
     * @param numeroMax
     * @param numeroMe
     * @param importancia
     * @param urgencia
     * @param estado
     * @param estabilidad
     * @return devuelve un requisito de información modificado con los parametros pasados por referencia
     */
    public RequisitoInformacion nuevoRI(int Id, String Nombre, String concepto, int valorMax, String UnidadTMax, int valorMe, String UnidadTMe, int numeroMax, int numeroMe, String importancia, String urgencia, String estado, String estabilidad, ArrayList<String> mDestino, ArrayList<String> mOrigen) {
        //// Creo la instancia
        RequisitoInformacion auxRI = new RequisitoInformacion();
        //// Asigno los valores a los atributos
        auxRI.setId("RI");
        auxRI.setId_n(Id);
        auxRI.setIdent(auxRI.getId()+String.valueOf(Id));
        auxRI.setNombre(Nombre);
        auxRI.setConcepto(concepto);
        auxRI.setValorMax(valorMax);
        auxRI.setValorMe(valorMe);
        auxRI.setUnidadTMax(UnidadTMax);
        auxRI.setUnidadTMe(UnidadTMe);
        auxRI.setNumeroMax(numeroMax);
        auxRI.setNumeroMe(valorMe);
        auxRI.setImportancia(importancia);
        auxRI.setEstado(estado);
        auxRI.setEstabilidad(estabilidad);
        auxRI.setUrgencia(urgencia);
        auxRI.setMDestino(mDestino);
        auxRI.setMOrigen(mOrigen);
        //// Enlazo el CasodeUso a la lista de CU que tiene el documento
        this.getRequisitoInformacion().add(auxRI);
        //persist(auxRI);
        return auxRI;
    }

    /**
     * Metodo para insertar un actor
     * @param Id
     * @param Nombre
     * @param descripcion
     * @return devuelve un actor modificado con los parametros pasados por referencia
     */
    public Actor nuevoA(int Id, String Nombre, String descripcion) {

        //// Creo la instancia
        Actor auxNA = new Actor();
        //// Asigno los valores a los atributos
        auxNA.setId("ACT");
        auxNA.setId_n(Id);
        auxNA.setIdent(auxNA.getId()+String.valueOf(Id));
        auxNA.setNombre(Nombre);
        auxNA.setDescripcion(descripcion);
        //// Enlazo el Actor a la lista de Actores que tiene el documento
        this.getActor().add(auxNA);
//        persist(auxNA);
        return auxNA;
    }

    /**
     * Metodo para insertar un objetivo
     * @param Id
     * @param Nombre
     * @param descripcion
     * @param importancia
     * @param urgencia
     * @param estado
     * @param estabilidad
     * @return devuelve un objetivo modificado con los parametros pasados por referencia
     */
    public Objetivo nuevoObjetivo(int Id, String Nombre, String descripcion, String importancia, String urgencia, String estado, String estabilidad, ArrayList<String> mDestino, ArrayList<String> mOrigen) {

        //// Creo la instancia
        Objetivo auxObj = new Objetivo();
        //// Asigno los valores a los atributos
        auxObj.setId("OB");
        auxObj.setId_n(Id);
        auxObj.setIdent(auxObj.getId()+String.valueOf(Id));
        auxObj.setNombre(Nombre);
        auxObj.setDescripcion(descripcion);
        auxObj.setEstabilidad(estabilidad);
        auxObj.setEstado(estado);
        auxObj.setUrgencia(urgencia);
        auxObj.setImportancia(importancia);
        auxObj.setMDestino(mDestino);
        auxObj.setMOrigen(mOrigen);
        //// Enlazo el Actor a la lista de Actores que tiene el documento
        this.getObjetivo().add(auxObj);
        //persist(auxObj);
        return auxObj;
    }

    /**
     * Metodo para insertar un participante
     * @param Id
     * @param Nombre
     * @param rol
     * @param organizacion
     * @param esCliente
     * @param esDesarrollador
     * @param esUsuario
     * @return devuelve un Participante modificado con los parametros pasados por referencia
     */
    public Participante nuevoPart(int Id, String Nombre, String rol, String organizacion, boolean esCliente, boolean esDesarrollador, boolean esUsuario) {

        //// Creo la instancia
        Participante auxP = new Participante();
        //// Asigno los valores a los atributos
        auxP.setId("PART");
        auxP.setId_n(Id);
        auxP.setIdent(auxP.getId()+String.valueOf(Id));
        auxP.setNombre(Nombre);
        auxP.setOrga(organizacion);
        auxP.setEsCliente(esCliente);
        auxP.setEsDesarrollador(esDesarrollador);
        auxP.setRol(rol);
        auxP.setEsUsuario(esUsuario);
        //// Enlazo el Actor a la lista de Actores que tiene el documento
        this.getParticipante().add(auxP);
        //persist(auxP);
        return auxP;
    }

    /**
     * Metodo para insertar una reunion
     * @param Id
     * @param Nombre
     * @param lugar
     * @param fecha
     * @param asistentes
     * @param Resultados
     * @return devuelve una reunion modificada con los parametros pasados por referencia
     */
    public Reunion NuevoReu(int Id, String Nombre, String lugar, String fecha, String asistentes, String Resultados) {

        //// Creo la instancia
        Reunion auxR = new Reunion();
        //// Asigno los valores a los atributos
        auxR.setId("REU");
        auxR.setId_n(Id);
        auxR.setIdent(auxR.getId()+String.valueOf(Id));
        auxR.setNombre(Nombre);
        auxR.setLugar(lugar);
        auxR.setFecha(fecha);
        auxR.setAsistentes(asistentes);
        auxR.setResultados(Resultados);
        //// Enlazo el Actor a la lista de Actores que tiene el documento
        this.getReunion().add(auxR);
        //persist(auxR);
        return auxR;
    }

    /**
     * Metodo para insertar un parrafo
     * @param Id
     * @param nombre
     * @param texto
     * @param tipo
     * @param comentarios
     * @return devuelve un parrafo modificada con los parametros pasados por referencia
     */
    public Parrafo nuevoParrafo(int Id, String nombre, String texto, boolean tipo, String comentarios) {

        //// Creo la instancia
        Parrafo auxPa = new Parrafo();
        //// Asigno los valores a los atributos
        auxPa.setId("PARR");
        auxPa.setId_n(Id);
        auxPa.setIdent(auxPa.getId()+String.valueOf(Id));
        auxPa.setNombre(nombre);
        auxPa.setTexto(texto);
        auxPa.setTipo(tipo);
        auxPa.setComentarios(comentarios);
        //// Enlazo el CasodeUso a la lista de CU que tiene el documento
        this.getParrafo().add(auxPa);
        //persist(auxPa);
        return auxPa;
    }

    /**
     * Metodo para insertar un fichero grafico
     * @param Id
     * @param nombre
     * @param fichero
     * @param comentarios
     * @return devuelve un fichero grafico modificada con los parametros pasados por referencia
     */
    public FicheroGrafico nuevoFichero(int Id, String nombre, File fichero, String comentarios) {

        //// Creo la instancia
        FicheroGrafico auxFich = new FicheroGrafico();
        //// Asigno los valores a los atributos
        auxFich.setId("FICH");
        auxFich.setId_n(Id);
        auxFich.setIdent(auxFich.getId()+String.valueOf(Id));
        auxFich.setNombre(nombre);
        auxFich.setFichero(fichero);
        auxFich.setComentarios(comentarios);
        //// Enlazo el CasodeUso a la lista de CU que tiene el documento
        this.getFicheroGrafico().add(auxFich);
        //persist(auxFich);
        return auxFich;
    }

    /**
     * Metodo para insertar una sección
     * @param Id
     * @param nombre
     * @param fuentes
     * @param autor
     * @param seccionNormal
     * @param seccionApendice
     * @param orden
     * @param comentarios
     * @return devuelve una seccion modificada con los parametros pasados por referencia
     */
    public Seccion nuevaSeccion(int Id, String nombre, boolean seccionNormal, boolean seccionApendice, boolean orden, String comentarios) {

        //// Creo la instancia
        Seccion auxSec = new Seccion();
        //// Asigno los valores a los atributos
        auxSec.setId("SECC");
        auxSec.setId_n(Id);
        auxSec.setIdent(auxSec.getId()+String.valueOf(Id));
        auxSec.setNombre(nombre);
        auxSec.setOrden(orden);
        auxSec.setSeccionNormal(seccionNormal);
        auxSec.setSeccionApendice(seccionApendice);

        auxSec.setComentarios(comentarios);
        //// Enlazo el CasodeUso a la lista de CU que tiene el documento
        this.getSeccion().add(auxSec);
        //persist(auxSec);
        return auxSec;
    }

    /**
     * Metodo para insertar una matriz de rastreabilidad
     * @param Id
     * @param nombre
     * @param fila
     * @param columna
     * @param comentarios
     * @return devuelve una matriz de rastreabilidad modificada con los parametros pasados por referencia
     */
    public MatrizRastreabilidad nuevaMatriz(int Id, String nombre, String fila, String columna, String comentarios) {

        //// Creo la instancia
        MatrizRastreabilidad auxMa = new MatrizRastreabilidad();
        //// Asigno los valores a los atributos
        auxMa.setId("MAT");
        auxMa.setId_n(Id);
        auxMa.setIdent(auxMa.getId()+String.valueOf(Id));
        auxMa.setNombre(nombre);
        auxMa.setFila(fila);
        auxMa.setColumna(columna);

        auxMa.setComentarios(comentarios);
        //// Enlazo el CasodeUso a la lista de CU que tiene el documento
        this.getMatrizRastreabilidad().add(auxMa);
        //persist(auxMa);
        return auxMa;
    }

    /**
     * Metodo para insertar una organización
     * @param Id
     * @param nombre
     * @param direccion
     * @param tlfn
     * @param fax
     * @param participantes
     * @param comentario
     * @return 
     */
    public Organizacion nuevaOrga(int Id, String nombre, String direccion, String tlfn, String fax, ArrayList<String> participante , String comentario) {
        //auxPar.toArray(participantes);
        //// Creo la instancia
        Organizacion auxOrg = new Organizacion();
        //// Asigno los valores a los atributos
        auxOrg.setId("ORG");
        auxOrg.setId_n(Id);
        auxOrg.setIdent(auxOrg.getId()+String.valueOf(Id));
        auxOrg.setNombre(nombre);
        auxOrg.setDireccion(direccion);
        auxOrg.setTelefono(tlfn);
        auxOrg.setFax(fax);
        auxOrg.setComentario(comentario);
        //// Enlazo el CasodeUso a la lista de CU que tiene el documento
        this.getOrganizacion().add(auxOrg);
        //persist(auxOrg);
        return auxOrg;
    }

/**
 * Metodo que permite crear el archivo xml con lo tenemos guardado en los arrays
 */
    public void toXML() {

        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        try {
            DocumentBuilder builder = factory.newDocumentBuilder();
            DOMImplementation implementation = builder.getDOMImplementation();

            Document document = implementation.createDocument(null, "xml", null);

            Element raiz = document.createElement("Documento");                 // Elemento raiz
            document.setXmlVersion("1.0");                                      // Versión de nuestro XML
            document.getDocumentElement().appendChild(raiz);                    // Pegamos la raiz al documento
            if (this.getNombre() != null) {
                Element eldoc = document.createElement("DocumentoR");

                Element elementoNombreDoc = document.createElement("nombre"); //creamos un nuevo elemento
                Text textNombreDoc = document.createTextNode(this.getNombre()); //Añadimos la informacion
                elementoNombreDoc.appendChild(textNombreDoc);
                eldoc.appendChild(elementoNombreDoc);

                Element elementoCreado = document.createElement("creado"); //creamos un nuevo elemento
                Text textCreado = document.createTextNode("Creado para: "+this.getCreador()); //Añadimos la informacion
                elementoCreado.appendChild(textCreado);
                eldoc.appendChild(elementoCreado);

                Element elementoFecha = document.createElement("fecha"); //creamos un nuevo elemento
                Text textFecha = document.createTextNode(this.getFecha()); //Añadimos la informacion
                elementoFecha.appendChild(textFecha);
                eldoc.appendChild(elementoFecha);

                Element elementoPreparado = document.createElement("preparado"); //creamos un nuevo elemento
                Text textPreparado = document.createTextNode("Preparado por: "+this.getPreparado()); //Añadimos la informacion
                elementoPreparado.appendChild(textPreparado);
                eldoc.appendChild(elementoPreparado);

                raiz.appendChild(eldoc);
            }
//CASO DE USO
            ArrayList<CasodeUso> casodeUso = this.getCasodeUso();
            for (int i = 0; i < casodeUso.size(); i++) {

                Element elementoCU = document.createElement("CasodeUso"); //creamos un nuevo elemento

                Element elementoIdent = document.createElement("identificacion"); //creamos un nuevo elemento
                Text textIdent = document.createTextNode(casodeUso.get(i).getIdent()); //Añadimos la informacion
                elementoIdent.appendChild(textIdent);
                elementoCU.appendChild(elementoIdent);

                Element elementoNombre = document.createElement("nombre"); //creamos un nuevo elemento
                Text textNombre = document.createTextNode(casodeUso.get(i).getNombre()); //Añadimos la informacion
                elementoNombre.appendChild(textNombre);
                elementoCU.appendChild(elementoNombre);

                Element elementoUniFrecu = document.createElement("unidadFrecuencia"); //creamos un nuevo elemento
                Text textUniFrecu = document.createTextNode(casodeUso.get(i).getUnidadFrecuencia()); //Añadimos la informacion
                elementoUniFrecu.appendChild(textUniFrecu);
                elementoCU.appendChild(elementoUniFrecu);

                Element elementoFrecu = document.createElement("frecuencia"); //creamos un nuevo elemento
                Text textFrecu = document.createTextNode(String.valueOf(casodeUso.get(i).getFrecuencia())); //Añadimos la informacion
                elementoFrecu.appendChild(textFrecu);
                elementoCU.appendChild(elementoFrecu);

                Element elementoEveAct = document.createElement("eventoActivacion"); //creamos un nuevo elemento
                Text textEveAct = document.createTextNode(casodeUso.get(i).getEventoActivacion());//Añadimos la informacion
                elementoEveAct.appendChild(textEveAct);
                elementoCU.appendChild(elementoEveAct);

                Element elementoPre = document.createElement("precondicion"); //creamos un nuevo elemento
                Text textPre = document.createTextNode(casodeUso.get(i).getPrecondicion()); //Añadimos la informacion
                elementoPre.appendChild(textPre);
                elementoCU.appendChild(elementoPre);

                Element elementoPost = document.createElement("postcondicion"); //creamos un nuevo elemento
                Text textPost = document.createTextNode(casodeUso.get(i).getPostcondicion()); //Añadimos la informacion
                elementoPost.appendChild(textPost);
                elementoCU.appendChild(elementoPost);

                Element elementoImportancia = document.createElement("importancia"); //creamos un nuevo elemento
                Text textImportancia = document.createTextNode(casodeUso.get(i).getImportancia()); //Añadimos la informacion
                elementoImportancia.appendChild(textImportancia);
                elementoCU.appendChild(elementoImportancia);

                Element elementoUrgencia = document.createElement("urgencia"); //creamos un nuevo elemento
                Text textUrgencia = document.createTextNode(casodeUso.get(i).getUrgencia()); //Añadimos la informacion
                elementoUrgencia.appendChild(textUrgencia);
                elementoCU.appendChild(elementoUrgencia);

                Element elementoEstabilidad = document.createElement("estabilidad"); //creamos un nuevo elemento
                Text textEstabilidad = document.createTextNode(casodeUso.get(i).getEstabilidad()); //Añadimos la informacion
                elementoEstabilidad.appendChild(textEstabilidad);
                elementoCU.appendChild(elementoEstabilidad);

                Element elementoEstado = document.createElement("estadodeDesarrollo"); //creamos un nuevo elemento
                Text textEstado = document.createTextNode(casodeUso.get(i).getEstadodeDesarrollo()); //Añadimos la informacion
                elementoEstado.appendChild(textEstado);
                elementoCU.appendChild(elementoEstado);
//PASO
                ArrayList<PasoCU> pasos = casodeUso.get(i).getPasoCU();
                for (int j = 0; j < pasos.size(); j++) {
                    //Saco información de los pasos.
                    Element elemPasos = document.createElement("PasoCU"); //creamos un nuevo elemento

                    Element elemIdentificacionPaso = document.createElement("identP"); //creamos un nuevo elemento
                    Text textIdentificaPaso = document.createTextNode(pasos.get(j).getIdent()); //Ingresamos la info
                    elemIdentificacionPaso.appendChild(textIdentificaPaso);
                    elemPasos.appendChild(elemIdentificacionPaso);

                    Element elemAccionPaso = document.createElement("accionP"); //creamos un nuevo elemento
                    Text textAccionPaso = document.createTextNode(pasos.get(j).getAccion()); //Ingresamos la info
                    elemAccionPaso.appendChild(textAccionPaso);
                    elemPasos.appendChild(elemAccionPaso);
//EXCEPCION
                    if(casodeUso.get(i).getPasoCU().get(j).getIdent().endsWith(String.valueOf(casodeUso.get(i).getId_n()))){
                    ArrayList<ExcepcionCU> excepciones = casodeUso.get(i).getPasoCU().get(j).getExcepcionCU();
                    for (int k = 0; k < excepciones.size(); k++) {
                        //Saco información de las excepciones
                        Element elemExcepcion = document.createElement("ExcepcionCU"); //creamos un nuevo elemento

                        Element elemIdentificacionEx = document.createElement("identE"); //creamos un nuevo elemento
                        Text textIdentificacionEx = document.createTextNode(excepciones.get(k).getIdent()); //Ingresamos la info
                        elemIdentificacionEx.appendChild(textIdentificacionEx);
                        elemExcepcion.appendChild(elemIdentificacionEx);

                        Element elemAccionEx = document.createElement("accionE"); //creamos un nuevo elemento
                        Text textAccionEx = document.createTextNode(excepciones.get(k).getAccion());//Ingresamos la info
                        elemAccionEx.appendChild(textAccionEx);
                        elemExcepcion.appendChild(elemAccionEx);

                        elemPasos.appendChild(elemExcepcion);
                    }
                    }
                    elementoCU.appendChild(elemPasos);
                }
                raiz.appendChild(elementoCU); //pegamos el elemento hijo a la raiz
            }
//SECCION
            ArrayList<Seccion> seccion = this.getSeccion();
            for (int i = 0; i < seccion.size(); i++) {

                Element elementoSeccion = document.createElement("Seccion"); //creamos un nuevo elemento

                Element elementoIdent = document.createElement("ident"); //creamos un nuevo elemento
                Text textIdent = document.createTextNode(seccion.get(i).getIdent());//Añadimos la informacion
                elementoIdent.appendChild(textIdent);
                elementoSeccion.appendChild(elementoIdent);

                Element elementoNom = document.createElement("nombre"); //creamos un nuevo elemento
                Text textNom = document.createTextNode(seccion.get(i).getNombre());//Añadimos la informacion
                elementoNom.appendChild(textNom);
                elementoSeccion.appendChild(elementoNom);

                Element elementoSecNor = document.createElement("seccionNormal"); //creamos un nuevo elemento
                Text textSecNor = document.createTextNode(Boolean.toString(seccion.get(i).getSeccionNormal())); //Añadimos la informacion
                elementoSecNor.appendChild(textSecNor);
                elementoSeccion.appendChild(elementoSecNor);

                Element elementoSecAp = document.createElement("seccionApendice"); //creamos un nuevo elemento
                Text textSecAp = document.createTextNode(Boolean.toString(seccion.get(i).getSeccionApendice())); //Añadimos la informacion
                elementoSecAp.appendChild(textSecAp);
                elementoSeccion.appendChild(elementoSecAp);

                Element elementoOrden = document.createElement("orden"); //creamos un nuevo elemento
                Text textOrden = document.createTextNode(Boolean.toString(seccion.get(i).getOrden())); ///Añadimos la informacion
                elementoOrden.appendChild(textOrden);
                elementoSeccion.appendChild(elementoOrden);

                Element elementoCom = document.createElement("comentarios"); //creamos un nuevo elemento
                Text textCom = document.createTextNode(seccion.get(i).getComentarios()); //Añadimos la informacion
                elementoCom.appendChild(textCom);
                elementoSeccion.appendChild(elementoCom);

                raiz.appendChild(elementoSeccion); //pegamos el elemento hijo a la raiz
            }
//PARRAFO
            ArrayList<Parrafo> parrafo = this.getParrafo();
            for (int i = 0; i < parrafo.size(); i++) {

                Element elementoParrafo = document.createElement("Parrafo"); //creamos un nuevo elemento

                Element elementoIdent = document.createElement("ident"); //creamos un nuevo elemento
                Text textIdent = document.createTextNode(parrafo.get(i).getIdent());//Añadimos la informacion
                elementoIdent.appendChild(textIdent);
                elementoParrafo.appendChild(elementoIdent);

                Element elementoNom = document.createElement("nombre"); //creamos un nuevo elemento
                Text textNom = document.createTextNode(parrafo.get(i).getNombre());//Añadimos la informacion
                elementoNom.appendChild(textNom);
                elementoParrafo.appendChild(elementoNom);

                Element elementoText = document.createElement("texto"); //creamos un nuevo elemento
                Text textText = document.createTextNode(parrafo.get(i).getTexto());//Añadimos la informacion
                elementoText.appendChild(textText);
                elementoParrafo.appendChild(elementoText);

                Element elementoTipo = document.createElement("tipoparrafo"); //creamos un nuevo elemento
                Text textTipo = document.createTextNode(Boolean.toString(parrafo.get(i).getTipo()));
                elementoTipo.appendChild(textTipo);
                elementoParrafo.appendChild(elementoTipo);

                Element elementoComentario = document.createElement("comentarios"); //creamos un nuevo elemento
                Text textComentario = document.createTextNode(parrafo.get(i).getComentarios()); //Añadimos la informacion
                elementoComentario.appendChild(textComentario);
                elementoParrafo.appendChild(elementoComentario);

                raiz.appendChild(elementoParrafo); //pegamos el elemento hijo a la raiz
            }
//FICHERO GRAFICO
            ArrayList<FicheroGrafico> fichero = this.getFicheroGrafico();
            for (int i = 0; i < fichero.size(); i++) {

                Element elementoFichero = document.createElement("FicheroGrafico"); //creamos un nuevo elemento

                Element elementoIdent = document.createElement("ident"); //creamos un nuevo elemento
                Text textIdent = document.createTextNode(fichero.get(i).getIdent());//Añadimos la informacion
                elementoIdent.appendChild(textIdent);
                elementoFichero.appendChild(elementoIdent);

                Element elementoNom = document.createElement("nombre"); //creamos un nuevo elemento
                Text textNom = document.createTextNode(fichero.get(i).getNombre());//Añadimos la informacion
                elementoNom.appendChild(textNom);
                elementoFichero.appendChild(elementoNom);

                Element elementoFich = document.createElement("fich"); //creamos un nuevo elemento
                Text textFich = document.createTextNode(String.valueOf(fichero.get(i).getFichero()));//Añadimos la informacion
                elementoFich.appendChild(textFich);
                elementoFichero.appendChild(elementoFich);

                Element elementoComentario = document.createElement("comentarios"); //creamos un nuevo elemento
                Text textComentario = document.createTextNode(fichero.get(i).getComentarios()); //Añadimos la informacion
                elementoComentario.appendChild(textComentario);
                elementoFichero.appendChild(elementoComentario);

                raiz.appendChild(elementoFichero);
            }
//ORGANIZACION
            ArrayList<Organizacion> organizacion = this.getOrganizacion();
            ArrayList<Participante> participante = this.getParticipante();
            for (int i = 0; i < organizacion.size(); i++) {

                Element elementoOrga = document.createElement("Organizacion"); //creamos un nuevo elemento

                Element elementoIdent = document.createElement("ident"); //creamos un nuevo elemento
                Text textIdent = document.createTextNode(organizacion.get(i).getIdent()); //Añadimos la informacion
                elementoIdent.appendChild(textIdent);
                elementoOrga.appendChild(elementoIdent);

                Element elementoNom = document.createElement("nombre"); //creamos un nuevo elemento
                Text textNom = document.createTextNode(organizacion.get(i).getNombre()); //Añadimos la informacion
                elementoNom.appendChild(textNom);
                elementoOrga.appendChild(elementoNom);

                Element elementoDir = document.createElement("direccion"); //creamos un nuevo elemento
                Text textDir = document.createTextNode(organizacion.get(i).getDireccion()); //Añadimos la informacion
                elementoDir.appendChild(textDir);
                elementoOrga.appendChild(elementoDir);

                Element elementoTlfn = document.createElement("tlfn"); //creamos un nuevo elemento
                Text textTlfn = document.createTextNode(organizacion.get(i).getTelefono()); //Añadimos la informacion
                elementoTlfn.appendChild(textTlfn);
                elementoOrga.appendChild(elementoTlfn);

                Element elementoFax = document.createElement("fax"); //creamos un nuevo elemento
                Text textFax = document.createTextNode(organizacion.get(i).getFax()); //Añadimos la informacion
                elementoFax.appendChild(textFax);
                elementoOrga.appendChild(elementoFax);

                for (int j = 0; j < participante.size(); j++) {
                    if (participante.get(j).getOrga().equals(organizacion.get(i).getIdent())) {

                        Element elemPar = document.createElement("PartiO"); //creamos un nuevo elemento

                        Element elementoIdentP = document.createElement("identP"); //creamos un nuevo elemento
                        Text textIdentP = document.createTextNode(participante.get(j).getIdent()); //Añadimos la informacion
                        elementoIdentP.appendChild(textIdentP);
                        elemPar.appendChild(elementoIdentP);

                        Element elementoNomP = document.createElement("nombreP"); //creamos un nuevo elemento
                        Text textNomP = document.createTextNode(participante.get(j).getNombre()); //Añadimos la informacion
                        elementoNomP.appendChild(textNomP);
                        elemPar.appendChild(elementoNomP);

                        elementoOrga.appendChild(elemPar);
                    }
                }

                Element elementoComent = document.createElement("comentario"); //creamos un nuevo elemento
                Text textComent = document.createTextNode(organizacion.get(i).getComentario()); //Añadimos la informacion
                elementoComent.appendChild(textComent);
                elementoOrga.appendChild(elementoComent);

                raiz.appendChild(elementoOrga); //pegamos el elemento hijo a la raiz
            }
//PARTICIPANTE
            for (int i = 0; i < participante.size(); i++) {

                Element elementoParticip = document.createElement("Participante"); //creamos un nuevo elemento

                Element elementoIdent = document.createElement("ident"); //creamos un nuevo elemento
                Text textIdent = document.createTextNode(participante.get(i).getIdent()); //Añadimos la informacion
                elementoIdent.appendChild(textIdent);
                elementoParticip.appendChild(elementoIdent);

                Element elementoNom = document.createElement("nombre"); //creamos un nuevo elemento
                Text textNom = document.createTextNode(participante.get(i).getNombre()); //Añadimos la informacion
                elementoNom.appendChild(textNom);
                elementoParticip.appendChild(elementoNom);

                Element elementoRol = document.createElement("rol"); //creamos un nuevo elemento
                Text textRol = document.createTextNode(participante.get(i).getRol());//Añadimos la informacion
                elementoRol.appendChild(textRol);
                elementoParticip.appendChild(elementoRol);

                Element elementoOrg = document.createElement("organizacion"); //creamos un nuevo elemento
                Text textOrg = document.createTextNode(participante.get(i).getOrga()); //Añadimos la informacion
                elementoOrg.appendChild(textOrg);
                elementoParticip.appendChild(elementoOrg);

                Element elementoEsCliente = document.createElement("esCliente"); //creamos un nuevo elemento
                Text textEscl = document.createTextNode(Boolean.toString(participante.get(i).getEsCliente())); //Añadimos la informacion
                elementoEsCliente.appendChild(textEscl);
                elementoParticip.appendChild(elementoEsCliente);

                Element elementoEsDesarr = document.createElement("esDesarrollador"); //creamos un nuevo elemento
                Text textEsDes = document.createTextNode(Boolean.toString(participante.get(i).getEsDesarrollador())); //Añadimos la informacion
                elementoEsDesarr.appendChild(textEsDes);
                elementoParticip.appendChild(elementoEsDesarr);

                Element elementoEsUsu = document.createElement("esUsuario"); //creamos un nuevo elemento
                Text textEsUsu = document.createTextNode(Boolean.toString(participante.get(i).getEsUsuario())); //Añadimos la informacion
                elementoEsUsu.appendChild(textEsUsu);
                elementoParticip.appendChild(elementoEsUsu);

                raiz.appendChild(elementoParticip); //pegamos el elemento hijo a la raiz
            }
//REUNION
            ArrayList<Reunion> reunion = this.getReunion();
            for (int i = 0; i < reunion.size(); i++) {

                Element elementoRe = document.createElement("Reunion"); //creamos un nuevo elemento

                Element elementoIdent = document.createElement("ident"); //creamos un nuevo elemento
                Text textIdent = document.createTextNode(reunion.get(i).getIdent()); //Añadimos la informacion
                elementoIdent.appendChild(textIdent);
                elementoRe.appendChild(elementoIdent);

                Element elementonombre = document.createElement("nombre"); //creamos un nuevo elemento
                Text textnom = document.createTextNode(reunion.get(i).getNombre()); //Añadimos la informacion
                elementonombre.appendChild(textnom);
                elementoRe.appendChild(elementonombre);

                Element elementolugar = document.createElement("LUGAR"); //creamos un nuevo elemento
                Text textlugar = document.createTextNode(reunion.get(i).getLugar()); //Añadimos la informacion
                elementolugar.appendChild(textlugar);
                elementoRe.appendChild(elementolugar);

                Element elementofecha = document.createElement("fecha"); //creamos un nuevo elemento
                Text textfec = document.createTextNode(reunion.get(i).getFecha()); //Añadimos la informacion
                elementofecha.appendChild(textfec);
                elementoRe.appendChild(elementofecha);

                Element elementoasist = document.createElement("asistentes"); //creamos un nuevo elemento
                Text textasis = document.createTextNode(reunion.get(i).getAsistentes()); //Añadimos la informacion
                elementoasist.appendChild(textasis);
                elementoRe.appendChild(elementoasist);

                Element elementoresult = document.createElement("resultados"); //creamos un nuevo elemento
                Text textres = document.createTextNode(reunion.get(i).getResultados());//Añadimos la informacion
                elementoresult.appendChild(textres);
                elementoRe.appendChild(elementoresult);

                raiz.appendChild(elementoRe); //pegamos el elemento hijo a la raiz
            }
//REQUISITO RESTRICCION
            ArrayList<RequisitoRestriccion> reqRestriccion = this.getRequisitoRestriccion();
            for (int i = 0; i < reqRestriccion.size(); i++) {

                Element elementoReqRes = document.createElement("RequisitoRestriccion"); //creamos un nuevo elemento

                Element elementoIdent = document.createElement("ident"); //creamos un nuevo elemento
                Text textIdent = document.createTextNode(reqRestriccion.get(i).getIdent()); //Añadimos la informacion
                elementoIdent.appendChild(textIdent);
                elementoReqRes.appendChild(elementoIdent);

                Element elementonombre = document.createElement("nombre"); //creamos un nuevo elemento
                Text textnombre = document.createTextNode(reqRestriccion.get(i).getNombre()); //Añadimos la informacion
                elementonombre.appendChild(textnombre);
                elementoReqRes.appendChild(elementonombre);

                Element elementodes = document.createElement("descripcion"); //creamos un nuevo elemento
                Text textdes = document.createTextNode(reqRestriccion.get(i).getDescripcion()); //Añadimos la informacion
                elementodes.appendChild(textdes);
                elementoReqRes.appendChild(elementodes);

                Element elementoimport = document.createElement("importancia"); //creamos un nuevo elemento
                Text textimport = document.createTextNode(reqRestriccion.get(i).getImportancia()); //Añadimos la informacion
                elementoimport.appendChild(textimport);
                elementoReqRes.appendChild(elementoimport);

                Element elementourgencia = document.createElement("urgencia"); //creamos un nuevo elemento
                Text texturgencia = document.createTextNode(reqRestriccion.get(i).getUrgencia()); //Añadimos la informacion
                elementourgencia.appendChild(texturgencia);
                elementoReqRes.appendChild(elementourgencia);

                Element elementoestado = document.createElement("estado"); //creamos un nuevo elemento
                Text textestado = document.createTextNode(reqRestriccion.get(i).getEstado()); //Añadimos la informacion
                elementoestado.appendChild(textestado);
                elementoReqRes.appendChild(elementoestado);

                Element elementoestabilidad = document.createElement("estabilidad"); //creamos un nuevo elemento
                Text textestabilidad = document.createTextNode(reqRestriccion.get(i).getEstabilidad()); //Añadimos la informacion
                elementoestabilidad.appendChild(textestabilidad);
                elementoReqRes.appendChild(elementoestabilidad);

                raiz.appendChild(elementoReqRes); //pegamos el elemento hijo a la raiz
            }
//REQUISITO INFORMACION
            ArrayList<RequisitoInformacion> reqInformacion = this.getRequisitoInformacion();
            for (int i = 0; i < reqInformacion.size(); i++) {

                Element elementoReqInformacion = document.createElement("RequisitoInformacion"); //creamos un nuevo elemento

                Element elementoIdent = document.createElement("ident"); //creamos un nuevo elemento
                Text textIdent = document.createTextNode(reqInformacion.get(i).getIdent()); //Añadimos la informacion
                elementoIdent.appendChild(textIdent);
                elementoReqInformacion.appendChild(elementoIdent);

                Element elementoNombre = document.createElement("Nombre"); //creamos un nuevo elemento
                Text textNombre = document.createTextNode(reqInformacion.get(i).getNombre()); //Añadimos la informacion
                elementoNombre.appendChild(textNombre);
                elementoReqInformacion.appendChild(elementoNombre);

                Element elementoConcepto = document.createElement("concepto"); //creamos un nuevo elemento
                Text textConcepto = document.createTextNode(reqInformacion.get(i).getConcepto());//Añadimos la informacion
                elementoConcepto.appendChild(textConcepto);
                elementoReqInformacion.appendChild(elementoConcepto);

                Element elementoValorMax = document.createElement("valorMax");
                Text textValorMax = document.createTextNode(Integer.toString(reqInformacion.get(i).getValorMax())); //Añadimos la informacion
                elementoValorMax.appendChild(textValorMax);
                elementoReqInformacion.appendChild(elementoValorMax);

                Element elementoUnidadTMax = document.createElement("unidadTMax");
                Text textUnidadTMax = document.createTextNode(reqInformacion.get(i).getUnidadTMax()); //Añadimos la informacion
                elementoUnidadTMax.appendChild(textUnidadTMax);
                elementoReqInformacion.appendChild(elementoUnidadTMax);

                Element elementoValorMe = document.createElement("valorMed");
                Text textValorMe = document.createTextNode(Integer.toString(reqInformacion.get(i).getValorMe())); //Ingresamos la info
                elementoValorMe.appendChild(textValorMe);
                elementoReqInformacion.appendChild(elementoValorMe);

                Element elementoUnidadTMe = document.createElement("unidadTMe");
                Text textUnidadTMe = document.createTextNode(reqInformacion.get(i).getUnidadTMe()); //Añadimos la informacion
                elementoValorMax.appendChild(textUnidadTMe);
                elementoReqInformacion.appendChild(elementoUnidadTMe);

                Element elementoNumMax = document.createElement("numeroMax");
                Text textNumMax = document.createTextNode(Integer.toString(reqInformacion.get(i).getNumeroMax())); //Añadimos la informacion
                elementoNumMax.appendChild(textNumMax);
                elementoReqInformacion.appendChild(elementoNumMax);

                Element elementoNumeroMed = document.createElement("numeroMed");
                Text textNumeroMed = document.createTextNode(Integer.toString(reqInformacion.get(i).getNumeroMe()));//Añadimos la informacion
                elementoNumeroMed.appendChild(textNumeroMed);
                elementoReqInformacion.appendChild(elementoNumeroMed);

                Element elementoImportancia = document.createElement("importancia");
                Text textImportancia = document.createTextNode(reqInformacion.get(i).getImportancia()); //Añadimos la informacion
                elementoImportancia.appendChild(textImportancia);
                elementoReqInformacion.appendChild(elementoImportancia);

                Element elementoUrgencia = document.createElement("urgencia");
                Text textUrgencia = document.createTextNode(reqInformacion.get(i).getUrgencia()); //Añadimos la informacion
                elementoUrgencia.appendChild(textUrgencia);
                elementoReqInformacion.appendChild(elementoUrgencia);

                Element elementoEstado = document.createElement("estado");
                Text textEstado = document.createTextNode(reqInformacion.get(i).getEstado()); //Añadimos la informacion
                elementoEstado.appendChild(textEstado);
                elementoReqInformacion.appendChild(elementoEstado);

                Element elementoEstabilidad = document.createElement("estabilidad");
                Text textEstabilidad = document.createTextNode(reqInformacion.get(i).getEstabilidad()); //Añadimos la informacion
                elementoEstabilidad.appendChild(textEstabilidad);
                elementoReqInformacion.appendChild(elementoEstabilidad);
//DATO ESPECIFICO
                ArrayList<DatoEspecifico> dato = reqInformacion.get(i).getDatoEspecifico();
                for (int j = 0; j < dato.size(); j++) {
                    //Saco información de los datos especificos.
                    Element elemDatoE = document.createElement("DatoEsp"); //creamos un nuevo elemento

                    Element elemIdentificacionDE = document.createElement("ident"); //creamos un nuevo elemento
                    Text textIdentificaDE = document.createTextNode(dato.get(j).getIdent()); //Ingresamos la info
                    elemIdentificacionDE.appendChild(textIdentificaDE);
                    elemDatoE.appendChild(elemIdentificacionDE);

                    Element elemDescripcionDE = document.createElement("descripcion"); //creamos un nuevo elemento
                    Text textDescrDE = document.createTextNode(dato.get(j).getDescripcion()); //Ingresamos la info
                    elemDescripcionDE.appendChild(textDescrDE);
                    elemDatoE.appendChild(elemDescripcionDE);

                    elementoReqInformacion.appendChild(elemDatoE);
                }
                raiz.appendChild(elementoReqInformacion); //pegamos el elemento hijo a la raiz
            }
//REQUISITO FUNCIONAL
            ArrayList<RequisitoFuncional> reqFuncional = this.getRequisitoFuncional();
            for (int i = 0; i < reqFuncional.size(); i++) {

                Element elementoReqFun = document.createElement("RequisitoFuncional"); //creamos un nuevo elemento

                Element elementoIdent = document.createElement("ident"); //creamos un nuevo elemento
                Text textIdent = document.createTextNode(reqFuncional.get(i).getIdent()); //Añadimos la informacion
                elementoIdent.appendChild(textIdent);
                elementoReqFun.appendChild(elementoIdent);

                Element elementonombre = document.createElement("nombre"); //creamos un nuevo elemento
                Text textnombre = document.createTextNode(reqFuncional.get(i).getNombre()); //Añadimos la informacion
                elementonombre.appendChild(textnombre);
                elementoReqFun.appendChild(elementonombre);

                Element elementodes = document.createElement("descripcion"); //creamos un nuevo elemento
                Text textdes = document.createTextNode(reqFuncional.get(i).getDescripcion()); //Añadimos la informacion
                elementodes.appendChild(textdes);
                elementoReqFun.appendChild(elementodes);

                Element elementoimport = document.createElement("importancia"); //creamos un nuevo elemento
                Text textimport = document.createTextNode(reqFuncional.get(i).getImportancia()); //Añadimos la informacion
                elementoimport.appendChild(textimport);
                elementoReqFun.appendChild(elementoimport);

                Element elementourgencia = document.createElement("urgencia"); //creamos un nuevo elemento
                Text texturgenc = document.createTextNode(reqFuncional.get(i).getUrgencia());//Añadimos la informacion
                elementourgencia.appendChild(texturgenc);
                elementoReqFun.appendChild(elementourgencia);

                Element elementoestado = document.createElement("estado"); //creamos un nuevo elemento
                Text textestado = document.createTextNode(reqFuncional.get(i).getEstado()); //Añadimos la informacion
                elementoestado.appendChild(textestado);
                elementoReqFun.appendChild(elementoestado);

                Element elementoestabilidad = document.createElement("estabilidad"); //creamos un nuevo elemento
                Text textestab = document.createTextNode(reqFuncional.get(i).getEstabilidad()); //Añadimos la informacion
                elementoestabilidad.appendChild(textestab);
                elementoReqFun.appendChild(elementoestabilidad);

                raiz.appendChild(elementoReqFun); //pegamos el elemento hijo a la raiz
            }

//REQUISITO NO FUNCIONAL
            ArrayList<RequisitoNoFuncional> reqNoFuncional = this.getRequisitoNoFuncional();
            for (int i = 0; i < reqNoFuncional.size(); i++) {

                Element elementoReqNoFun = document.createElement("RequisitoNoFuncional"); //creamos un nuevo elemento

                Element elementoIdent = document.createElement("ident"); //creamos un nuevo elemento
                Text textIdent = document.createTextNode(reqNoFuncional.get(i).getIdent()); //Añadimos la informacion
                elementoIdent.appendChild(textIdent);
                elementoReqNoFun.appendChild(elementoIdent);

                Element elementonombre = document.createElement("nombre"); //creamos un nuevo elemento
                Text textnombre = document.createTextNode(reqNoFuncional.get(i).getNombre()); //Añadimos la informacion
                elementonombre.appendChild(textnombre);
                elementoReqNoFun.appendChild(elementonombre);

                Element elementodes = document.createElement("descripcion"); //creamos un nuevo elemento
                Text textdes = document.createTextNode(reqNoFuncional.get(i).getDescripcion()); //Añadimos la informacion
                elementodes.appendChild(textdes);
                elementoReqNoFun.appendChild(elementodes);

                Element elementoimport = document.createElement("importancia"); //creamos un nuevo elemento
                Text textimport = document.createTextNode(reqNoFuncional.get(i).getImportancia()); //Añadimos la informacion
                elementoimport.appendChild(textimport);
                elementoReqNoFun.appendChild(elementoimport);

                Element elementourgencia = document.createElement("urgencia"); //creamos un nuevo elemento
                Text texturg = document.createTextNode(reqNoFuncional.get(i).getUrgencia()); //Añadimos la informacion
                elementourgencia.appendChild(texturg);
                elementoReqNoFun.appendChild(elementourgencia);

                Element elementoestado = document.createElement("estado"); //creamos un nuevo elemento
                Text textest = document.createTextNode(reqNoFuncional.get(i).getEstado()); //Añadimos la informacion
                elementoestado.appendChild(textest);
                elementoReqNoFun.appendChild(elementoestado);

                Element elementoestabilidad = document.createElement("estabilidad"); //creamos un nuevo elemento
                Text textesta = document.createTextNode(reqNoFuncional.get(i).getEstabilidad());//Añadimos la informacion
                elementoestabilidad.appendChild(textesta);
                elementoReqNoFun.appendChild(elementoestabilidad);

                raiz.appendChild(elementoReqNoFun); //pegamos el elemento hijo a la raiz
            }
//ACTOR
            ArrayList<Actor> actor = this.getActor();
            for (int i = 0; i < actor.size(); i++) {

                Element elementoActor = document.createElement("Actor"); //creamos un nuevo elemento

                Element elementoIdent = document.createElement("identificacion"); //creamos un nuevo elemento
                Text textIdent = document.createTextNode(actor.get(i).getIdent()); //Añadimos la informacion
                elementoIdent.appendChild(textIdent);
                elementoActor.appendChild(elementoIdent);

                Element elementoNom = document.createElement("nombre"); //creamos un nuevo elemento
                Text textNom = document.createTextNode(actor.get(i).getNombre()); //Añadimos la informacion
                elementoNom.appendChild(textNom);
                elementoActor.appendChild(elementoNom);

                Element elementoDescrip = document.createElement("descripcion"); //creamos un nuevo elemento
                Text textDes = document.createTextNode(actor.get(i).getDescripcion());//Añadimos la informacion
                elementoDescrip.appendChild(textDes);
                elementoActor.appendChild(elementoDescrip);

                raiz.appendChild(elementoActor); //pegamos el elemento hijo a la raiz
            }
//OBJETIVO
            ArrayList<Objetivo> objetivo = this.getObjetivo();
            for (int i = 0; i < objetivo.size(); i++) {

                Element elementoObjetivo = document.createElement("Objetivo"); //creamos un nuevo elemento

                Element elementoIdent = document.createElement("ident"); //creamos un nuevo elemento
                Text textIdent = document.createTextNode(objetivo.get(i).getIdent());//Añadimos la informacion
                elementoIdent.appendChild(textIdent);
                elementoObjetivo.appendChild(elementoIdent);

                Element elementoNom = document.createElement("nombre"); //creamos un nuevo elemento
                Text textNom = document.createTextNode(objetivo.get(i).getNombre());//Añadimos la informacion
                elementoNom.appendChild(textNom);
                elementoObjetivo.appendChild(elementoNom);

                Element elementoDescrip = document.createElement("descripcion"); //creamos un nuevo elemento
                Text textDes = document.createTextNode(objetivo.get(i).getDescripcion()); //Añadimos la informacion
                elementoDescrip.appendChild(textDes);
                elementoObjetivo.appendChild(elementoDescrip);

                Element elementoImpor = document.createElement("importancia"); //creamos un nuevo elemento
                Text textImp = document.createTextNode(objetivo.get(i).getImportancia()); //Añadimos la informacion
                elementoImpor.appendChild(textImp);
                elementoObjetivo.appendChild(elementoImpor);

                Element elementoUrgen = document.createElement("urgencia"); //creamos un nuevo elemento
                Text textUr = document.createTextNode(objetivo.get(i).getUrgencia()); //Añadimos la informacion
                elementoUrgen.appendChild(textUr);
                elementoObjetivo.appendChild(elementoUrgen);

                Element elementoEstado = document.createElement("estado"); //creamos un nuevo elemento
                Text textEst = document.createTextNode(objetivo.get(i).getEstado()); //Añadimos la informacion
                elementoEstado.appendChild(textEst);
                elementoObjetivo.appendChild(elementoEstado);

                Element elementoEstabilidad = document.createElement("estabilidad"); //creamos un nuevo elemento
                Text textEstb = document.createTextNode(objetivo.get(i).getEstabilidad()); ///Añadimos la informacion
                elementoEstabilidad.appendChild(textEstb);
                elementoObjetivo.appendChild(elementoEstabilidad);
//SUBOBJETIVO
                ArrayList<Subobjetivo> subo = objetivo.get(i).getSubobjetivo();
                for (int j = 0; j < subo.size(); j++) {
                    //Saco información de los subobjetivos.
                    Element elemSUBO = document.createElement("Subobjetivo"); //creamos un nuevo elemento

                    Element elemIdentificacionSUBO = document.createElement("identSO"); //creamos un nuevo elemento
                    Text textIdentificaSUBO = document.createTextNode(subo.get(j).getIdent()); //Ingresamos la info
                    elemIdentificacionSUBO.appendChild(textIdentificaSUBO);
                    elemSUBO.appendChild(elemIdentificacionSUBO);

                    Element elemDescripcionSUBO = document.createElement("descripcionSO"); //creamos un nuevo elemento
                    Text textDescrSUBO = document.createTextNode(subo.get(j).getDescripcion()); //Ingresamos la info
                    elemDescripcionSUBO.appendChild(textDescrSUBO);
                    elemSUBO.appendChild(elemDescripcionSUBO);

                    elementoObjetivo.appendChild(elemSUBO);
                    }
                raiz.appendChild(elementoObjetivo); //pegamos el elemento hijo a la raiz
            }
//MATRIZ RASTREABILIDAD
            ArrayList<MatrizRastreabilidad> matriz = this.getMatrizRastreabilidad();
            for (int i = 0; i < matriz.size(); i++) {

                Element elementoMatriz = document.createElement("MatrizRastreabilidad"); //creamos un nuevo elemento

                Element elementoIdent = document.createElement("ident"); //creamos un nuevo elemento
                Text textIdent = document.createTextNode(matriz.get(i).getIdent());//Añadimos la informacion
                elementoIdent.appendChild(textIdent);
                elementoMatriz.appendChild(elementoIdent);

                Element elementoNom = document.createElement("nombre"); //creamos un nuevo elemento
                Text textNom = document.createTextNode(matriz.get(i).getNombre());//Añadimos la informacion
                elementoNom.appendChild(textNom);
                elementoMatriz.appendChild(elementoNom);

                Element elementoCom = document.createElement("comentarios"); //creamos un nuevo elemento
                Text textCom = document.createTextNode(matriz.get(i).getComentarios()); //Añadimos la informacion
                elementoCom.appendChild(textCom);
                elementoMatriz.appendChild(elementoCom);
                
                for(int ob=0; ob < objetivo.size(); ob++){
                    if (matriz.get(i).getColumna().equals("Objetivo")) {
                        Element elementocolumna = document.createElement("mColumna");

                        Element elementoObj = document.createElement("cm"); //creamos un nuevo elemento
                        Text textObj = document.createTextNode(objetivo.get(ob).getIdent()); //Añadimos la informacion
                        elementoObj.appendChild(textObj);
                        elementocolumna.appendChild(elementoObj);
                        elementoMatriz.appendChild(elementocolumna);

                        if(matriz.get(i).getFila().equals("RequisitoInformación")){
                            for(int m=0; m<reqInformacion.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoRI = document.createElement("fm"); //creamos un nuevo elemento
                                Text textRI = document.createTextNode(reqInformacion.get(m).getIdent()); //Añadimos la informacion
                                elementoRI.appendChild(textRI);
                                elementofila.appendChild(elementoRI);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (objetivo.get(ob).getMOrigen().size() == 0) {
                                    for (int ri=0; ri<reqInformacion.size();ri++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < objetivo.get(ob).getMOrigen().size(); n++) {
                                        if (reqInformacion.get(m).getIdent().equals(objetivo.get(ob).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                        if(matriz.get(i).getFila().equals("RequisitoRestricción")){
                            for(int m=0; m<reqRestriccion.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoRR = document.createElement("fm"); //creamos un nuevo elemento
                                Text textRR = document.createTextNode(reqRestriccion.get(m).getIdent()); //Añadimos la informacion
                                elementoRR.appendChild(textRR);
                                elementofila.appendChild(elementoRR);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (objetivo.get(ob).getMOrigen().size() == 0) {
                                    for (int rr=0; rr<reqRestriccion.size();rr++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < objetivo.get(ob).getMOrigen().size(); n++) {
                                        if (reqRestriccion.get(m).getIdent().equals(objetivo.get(ob).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                        if(matriz.get(i).getFila().equals("RequisitoFuncional")){
                            for(int m=0; m<reqFuncional.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoRF = document.createElement("fm"); //creamos un nuevo elemento
                                Text textRF = document.createTextNode(reqFuncional.get(m).getIdent()); //Añadimos la informacion
                                elementoRF.appendChild(textRF);
                                elementofila.appendChild(elementoRF);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (objetivo.get(ob).getMOrigen().size() == 0) {
                                    for (int rf=0; rf<reqFuncional.size();rf++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < objetivo.get(ob).getMOrigen().size(); n++) {
                                        if (reqFuncional.get(m).getIdent().equals(objetivo.get(ob).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                        if(matriz.get(i).getFila().equals("RequisitoNoFuncional")){
                            for(int m=0; m<reqNoFuncional.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoRNF = document.createElement("fm"); //creamos un nuevo elemento
                                Text textRNF = document.createTextNode(reqNoFuncional.get(m).getIdent()); //Añadimos la informacion
                                elementoRNF.appendChild(textRNF);
                                elementofila.appendChild(elementoRNF);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (objetivo.get(ob).getMOrigen().size() == 0) {
                                    for (int rnf=0; rnf<reqNoFuncional.size();rnf++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < objetivo.get(ob).getMOrigen().size(); n++) {
                                        if (reqNoFuncional.get(m).getIdent().equals(objetivo.get(ob).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                    }
                }
                for(int ri2=0; ri2 < reqInformacion.size(); ri2++){
                    if (matriz.get(i).getColumna().equals("RequisitoInformación")) {
                        Element elementocolumna = document.createElement("mColumna");

                        Element elementoRI = document.createElement("cm"); //creamos un nuevo elemento
                        Text textRI = document.createTextNode(reqInformacion.get(ri2).getIdent()); //Añadimos la informacion
                        elementoRI.appendChild(textRI);
                        elementocolumna.appendChild(elementoRI);
                        elementoMatriz.appendChild(elementocolumna);

                        if(matriz.get(i).getFila().equals("Objetivo")){
                            for(int m=0; m<objetivo.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoOb = document.createElement("fm"); //creamos un nuevo elemento
                                Text textOb = document.createTextNode(objetivo.get(m).getIdent()); //Añadimos la informacion
                                elementoOb.appendChild(textOb);
                                elementofila.appendChild(elementoOb);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (reqInformacion.get(ri2).getMOrigen().size() == 0) {
                                    for (int ob=0; ob<objetivo.size();ob++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < reqInformacion.get(ri2).getMOrigen().size(); n++) {
                                        if (objetivo.get(m).getIdent().equals(reqInformacion.get(ri2).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                        if(matriz.get(i).getFila().equals("RequisitoRestricción")){
                            for(int m=0; m<reqRestriccion.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoRR = document.createElement("fm"); //creamos un nuevo elemento
                                Text textRR = document.createTextNode(reqRestriccion.get(m).getIdent()); //Añadimos la informacion
                                elementoRR.appendChild(textRR);
                                elementofila.appendChild(elementoRR);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (reqInformacion.get(ri2).getMOrigen().size() == 0) {
                                    for (int rr=0; rr<reqRestriccion.size();rr++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < reqInformacion.get(ri2).getMOrigen().size(); n++) {
                                        if (reqRestriccion.get(m).getIdent().equals(reqInformacion.get(ri2).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                        if(matriz.get(i).getFila().equals("RequisitoFuncional")){
                            for(int m=0; m<reqFuncional.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoRF = document.createElement("fm"); //creamos un nuevo elemento
                                Text textRF = document.createTextNode(reqFuncional.get(m).getIdent()); //Añadimos la informacion
                                elementoRF.appendChild(textRF);
                                elementofila.appendChild(elementoRF);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (reqInformacion.get(ri2).getMOrigen().size() == 0) {
                                    for (int rf=0; rf<reqFuncional.size();rf++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < reqInformacion.get(ri2).getMOrigen().size(); n++) {
                                        if (reqFuncional.get(m).getIdent().equals(reqInformacion.get(ri2).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                        if(matriz.get(i).getFila().equals("RequisitoNoFuncional")){
                            for(int m=0; m<reqNoFuncional.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoRNF = document.createElement("fm"); //creamos un nuevo elemento
                                Text textRNF = document.createTextNode(reqNoFuncional.get(m).getIdent()); //Añadimos la informacion
                                elementoRNF.appendChild(textRNF);
                                elementofila.appendChild(elementoRNF);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (reqInformacion.get(ri2).getMOrigen().size() == 0) {
                                    for (int rnf=0; rnf<reqNoFuncional.size();rnf++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < reqInformacion.get(ri2).getMOrigen().size(); n++) {
                                        if (reqNoFuncional.get(m).getIdent().equals(reqInformacion.get(ri2).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                    }
                }
                for(int rr1=0; rr1 < reqRestriccion.size(); rr1++){
                    if (matriz.get(i).getColumna().equals("RequisitoRestricción")) {
                        Element elementocolumna = document.createElement("mColumna");

                        Element elementoRR = document.createElement("cm"); //creamos un nuevo elemento
                        Text textRR = document.createTextNode(reqRestriccion.get(rr1).getIdent()); //Añadimos la informacion
                        elementoRR.appendChild(textRR);
                        elementocolumna.appendChild(elementoRR);
                        elementoMatriz.appendChild(elementocolumna);

                        if(matriz.get(i).getFila().equals("RequisitoInformación")){
                            for(int m=0; m<reqInformacion.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoRI = document.createElement("fm"); //creamos un nuevo elemento
                                Text textRI = document.createTextNode(reqInformacion.get(m).getIdent()); //Añadimos la informacion
                                elementoRI.appendChild(textRI);
                                elementofila.appendChild(elementoRI);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (reqRestriccion.get(rr1).getMOrigen().size() == 0) {
                                    for (int ri=0; ri<reqInformacion.size();ri++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < reqRestriccion.get(rr1).getMOrigen().size(); n++) {
                                        if (reqInformacion.get(m).getIdent().equals(reqRestriccion.get(rr1).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                        if(matriz.get(i).getFila().equals("Objetivo")){
                            for(int m=0; m<objetivo.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoObj = document.createElement("fm"); //creamos un nuevo elemento
                                Text textObj = document.createTextNode(objetivo.get(m).getIdent()); //Añadimos la informacion
                                elementoObj.appendChild(textObj);
                                elementofila.appendChild(elementoObj);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (reqRestriccion.get(rr1).getMOrigen().size() == 0) {
                                    for (int obj=0; obj<objetivo.size();obj++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < reqRestriccion.get(rr1).getMOrigen().size(); n++) {
                                        if (objetivo.get(m).getIdent().equals(reqRestriccion.get(rr1).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                        if(matriz.get(i).getFila().equals("RequisitoFuncional")){
                            for(int m=0; m<reqFuncional.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoRF = document.createElement("fm"); //creamos un nuevo elemento
                                Text textRF = document.createTextNode(reqFuncional.get(m).getIdent()); //Añadimos la informacion
                                elementoRF.appendChild(textRF);
                                elementofila.appendChild(elementoRF);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (reqRestriccion.get(rr1).getMOrigen().size() == 0) {
                                    for (int rf=0; rf<reqFuncional.size();rf++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < reqRestriccion.get(rr1).getMOrigen().size(); n++) {
                                        if (reqFuncional.get(m).getIdent().equals(reqRestriccion.get(rr1).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                        if(matriz.get(i).getFila().equals("RequisitoNoFuncional")){
                            for(int m=0; m<reqNoFuncional.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoRNF = document.createElement("fm"); //creamos un nuevo elemento
                                Text textRNF = document.createTextNode(reqNoFuncional.get(m).getIdent()); //Añadimos la informacion
                                elementoRNF.appendChild(textRNF);
                                elementofila.appendChild(elementoRNF);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (reqRestriccion.get(rr1).getMOrigen().size() == 0) {
                                    for (int rnf=0; rnf<reqNoFuncional.size();rnf++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < reqRestriccion.get(rr1).getMOrigen().size(); n++) {
                                        if (reqNoFuncional.get(m).getIdent().equals(reqRestriccion.get(rr1).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                    }
                }
                for(int rf1=0; rf1 < reqFuncional.size(); rf1++){
                    if (matriz.get(i).getColumna().equals("RequisitoFuncional")) {
                        Element elementocolumna = document.createElement("mColumna");

                        Element elementoRF = document.createElement("cm"); //creamos un nuevo elemento
                        Text textRF = document.createTextNode(reqFuncional.get(rf1).getIdent()); //Añadimos la informacion
                        elementoRF.appendChild(textRF);
                        elementocolumna.appendChild(elementoRF);
                        elementoMatriz.appendChild(elementocolumna);

                        if(matriz.get(i).getFila().equals("RequisitoInformación")){
                            for(int m=0; m<reqInformacion.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoRI = document.createElement("fm"); //creamos un nuevo elemento
                                Text textRI = document.createTextNode(reqInformacion.get(m).getIdent()); //Añadimos la informacion
                                elementoRI.appendChild(textRI);
                                elementofila.appendChild(elementoRI);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (reqFuncional.get(rf1).getMOrigen().size() == 0) {
                                    for (int ri=0; ri<reqInformacion.size();ri++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < reqFuncional.get(rf1).getMOrigen().size(); n++) {
                                        if (reqInformacion.get(m).getIdent().equals(reqFuncional.get(rf1).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                        if(matriz.get(i).getFila().equals("RequisitoRestricción")){
                            for(int m=0; m<reqRestriccion.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoRR = document.createElement("fm"); //creamos un nuevo elemento
                                Text textRR = document.createTextNode(reqRestriccion.get(m).getIdent()); //Añadimos la informacion
                                elementoRR.appendChild(textRR);
                                elementofila.appendChild(elementoRR);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (reqFuncional.get(rf1).getMOrigen().size() == 0) {
                                    for (int rr=0; rr<reqRestriccion.size();rr++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < objetivo.get(rf1).getMOrigen().size(); n++) {
                                        if (reqRestriccion.get(m).getIdent().equals(objetivo.get(rf1).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                        if(matriz.get(i).getFila().equals("Objetivo")){
                            for(int m=0; m<objetivo.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoObj = document.createElement("fm"); //creamos un nuevo elemento
                                Text textObj = document.createTextNode(objetivo.get(m).getIdent()); //Añadimos la informacion
                                elementoObj.appendChild(textObj);
                                elementofila.appendChild(elementoObj);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (reqFuncional.get(rf1).getMOrigen().size() == 0) {
                                    for (int obj=0; obj<objetivo.size();obj++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < reqFuncional.get(rf1).getMOrigen().size(); n++) {
                                        if (objetivo.get(m).getIdent().equals(reqFuncional.get(rf1).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                        if(matriz.get(i).getFila().equals("RequisitoNoFuncional")){
                            for(int m=0; m<reqNoFuncional.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoRNF = document.createElement("fm"); //creamos un nuevo elemento
                                Text textRNF = document.createTextNode(reqNoFuncional.get(m).getIdent()); //Añadimos la informacion
                                elementoRNF.appendChild(textRNF);
                                elementofila.appendChild(elementoRNF);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (reqFuncional.get(rf1).getMOrigen().size() == 0) {
                                    for (int rnf=0; rnf<reqNoFuncional.size();rnf++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < reqFuncional.get(rf1).getMOrigen().size(); n++) {
                                        if (reqNoFuncional.get(m).getIdent().equals(objetivo.get(rf1).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                    }
                }
                for(int rnf1=0; rnf1 < objetivo.size(); rnf1++){
                    if (matriz.get(i).getColumna().equals("RequisitoNoFuncional")) {
                        Element elementocolumna = document.createElement("mColumna");

                        Element elementoRNF = document.createElement("cm"); //creamos un nuevo elemento
                        Text textRNF = document.createTextNode(reqNoFuncional.get(rnf1).getIdent()); //Añadimos la informacion
                        elementoRNF.appendChild(textRNF);
                        elementocolumna.appendChild(elementoRNF);
                        elementoMatriz.appendChild(elementocolumna);

                        if(matriz.get(i).getFila().equals("RequisitoInformación")){
                            for(int m=0; m<reqInformacion.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoRI = document.createElement("fm"); //creamos un nuevo elemento
                                Text textRI = document.createTextNode(reqInformacion.get(m).getIdent()); //Añadimos la informacion
                                elementoRI.appendChild(textRI);
                                elementofila.appendChild(elementoRI);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (reqNoFuncional.get(rnf1).getMOrigen().size() == 0) {
                                    for (int ri=0; ri<reqInformacion.size();ri++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < reqNoFuncional.get(rnf1).getMOrigen().size(); n++) {
                                        if (reqInformacion.get(m).getIdent().equals(reqNoFuncional.get(rnf1).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                        if(matriz.get(i).getFila().equals("RequisitoRestricción")){
                            for(int m=0; m<reqRestriccion.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoRR = document.createElement("fm"); //creamos un nuevo elemento
                                Text textRR = document.createTextNode(reqRestriccion.get(m).getIdent()); //Añadimos la informacion
                                elementoRR.appendChild(textRR);
                                elementofila.appendChild(elementoRR);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (reqNoFuncional.get(rnf1).getMOrigen().size() == 0) {
                                    for (int rr=0; rr<reqRestriccion.size();rr++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < reqNoFuncional.get(rnf1).getMOrigen().size(); n++) {
                                        if (reqRestriccion.get(m).getIdent().equals(reqNoFuncional.get(rnf1).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                        if(matriz.get(i).getFila().equals("RequisitoFuncional")){
                            for(int m=0; m<reqFuncional.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoRF = document.createElement("fm"); //creamos un nuevo elemento
                                Text textRF = document.createTextNode(reqFuncional.get(m).getIdent()); //Añadimos la informacion
                                elementoRF.appendChild(textRF);
                                elementofila.appendChild(elementoRF);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (reqNoFuncional.get(rnf1).getMOrigen().size() == 0) {
                                    for (int rf=0; rf<reqFuncional.size();rf++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < reqNoFuncional.get(rnf1).getMOrigen().size(); n++) {
                                        if (reqFuncional.get(m).getIdent().equals(reqNoFuncional.get(rnf1).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                        if(matriz.get(i).getFila().equals("Objetivo")){
                            for(int m=0; m<objetivo.size();m++){

                                Element elementofila = document.createElement("mFila");

                                Element elementoObj= document.createElement("fm"); //creamos un nuevo elemento
                                Text textObj = document.createTextNode(objetivo.get(m).getIdent()); //Añadimos la informacion
                                elementoObj.appendChild(textObj);
                                elementofila.appendChild(elementoObj);

                                Element elementoaux = document.createElement("aux");
                                Element elementotraza = document.createElement("traza");

                                if (reqNoFuncional.get(rnf1).getMOrigen().size() == 0) {
                                    for (int obj=0; obj<objetivo.size();obj++) {
                                        Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                        elementotraza.appendChild(texttr);
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                } else {
                                    for (int n = 0; n < reqNoFuncional.get(rnf1).getMOrigen().size(); n++) {
                                        if (objetivo.get(m).getIdent().equals(reqNoFuncional.get(rnf1).getMOrigen().get(n))) {
                                            Text texttr = document.createTextNode("tr2"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        } else {
                                            Text texttr = document.createTextNode("tr1"); //Añadimos la informacion
                                            elementotraza.appendChild(texttr);
                                        }
                                        elementoaux.appendChild(elementotraza);
                                        elementofila.appendChild(elementoaux);
                                    }
                                    elementoMatriz.appendChild(elementofila);
                                }
                            }
                        }
                    }
                }
                raiz.appendChild(elementoMatriz); //pegamos el elemento hijo a la raiz
            }

            Source source = new DOMSource(document);
            Result result = new StreamResult(new java.io.File("resultado.xml")); //nombre del archivo
            Result console = new StreamResult(System.out);
            Transformer transformer = TransformerFactory.newInstance().newTransformer();
            transformer.transform(source, result);
            transformer.transform(source, console);
        } catch (Exception e) {
            System.err.println("Error: " + e);
        }
    }

    /**
     * Metodo que devuelve solo la parte cadena del identificador
     * @return la cadena id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que inserta solo la parte cadena del identificador
     * @param la cadena id a insertar
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Metodo que devuelve solo la parte número del identificador
     * @return el entero id
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que inserta solo la parte número del identificador
     * @param el entero id a insertar
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve el identificador completo
     * @return el identificador
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que inserta el identificador completo
     * @param ident identificador completo a insertar
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve el nombre del Documento de requisitos
     * @return el nombre del documento
     */
    public String getNombre() {
        return nombre;
    }

    /**
     * Metodo que inserta una cadena con el nombre del documento
     * @param nombre del documento
     */
    public void setNombre(String nombre) {
        this.nombre = nombre;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devolvera el nombre del creador
     * @return la cadena del creador
     */
    public String getCreador() {
        return creador;
    }

    /**
     * Metodo que inserta una cadena con el nombre del creador
     * @param creador que es la cadena del nombre del creador
     */
    public void setCreador(String creador) {
        this.creador = creador;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve la fecha de creacion del documento
     * @return la fecha de creacion del documento
     */
    public String getFecha() {
        return fecha;
    }

    /**
     * Metodo que inserta la cadena de la fecha de creacion
     * @param fecha es la cadena que dice la fecha de creacion del documento
     */
    public void setFecha(String fecha) {
        this.fecha = fecha;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve una cadena con el comentario del documento
     * @return la cadena con el comentario
     */
    public String getComentario() {
        return comentario;
    }

    /**
     * Metodo que inserta una cadena con el comentario del documento
     * @param comentario es la cadena con la informacion del comentario
     */
    public void setComentario(String comentario) {
        this.comentario = comentario;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve la cadena de preparado
     * @return la cadena preparado
     */
    public String getPreparado() {
        return preparado;
    }

    /**
     * Metodo que inserta la cadena preparado del documento
     * @param preparado es la cadena donde informa si esta preparado
     */
    public void setPreparado(String preparado) {
        this.preparado = preparado;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * @return the lIdentCU
     */
    public ArrayList<Integer> getLIdentCU() {
        return lIdentCU;
    }

    /**
     * @param lIdentCU the lIdentCU to set
     */
    public void setLIdentCU(ArrayList<Integer> lIdentCU) {
        this.lIdentCU = lIdentCU;
    }

    /**
     * @return the lIdentSE
     */
    public ArrayList<Integer> getLIdentSE() {
        return lIdentSE;
    }

    /**
     * @param lIdentSE the lIdentSE to set
     */
    public void setLIdentSE(ArrayList<Integer> lIdentSE) {
        this.lIdentSE = lIdentSE;
    }

    /**
     * @return the lIdentPRR
     */
    public ArrayList<Integer> getLIdentPRR() {
        return lIdentPRR;
    }

    /**
     * @param lIdentPRR the lIdentPRR to set
     */
    public void setLIdentPRR(ArrayList<Integer> lIdentPRR) {
        this.lIdentPRR = lIdentPRR;
    }

    /**
     * @return the lIdentFI
     */
    public ArrayList<Integer> getLIdentFI() {
        return lIdentFI;
    }

    /**
     * @param lIdentFI the lIdentFI to set
     */
    public void setLIdentFI(ArrayList<Integer> lIdentFI) {
        this.lIdentFI = lIdentFI;
    }

    /**
     * @return the lIdentOR
     */
    public ArrayList<Integer> getLIdentOR() {
        return lIdentOR;
    }

    /**
     * @param lIdentOR the lIdentOR to set
     */
    public void setLIdentOR(ArrayList<Integer> lIdentOR) {
        this.lIdentOR = lIdentOR;
    }

    /**
     * @return the lIdentPA
     */
    public ArrayList<Integer> getLIdentPA() {
        return lIdentPA;
    }

    /**
     * @param lIdentPA the lIdentPA to set
     */
    public void setLIdentPA(ArrayList<Integer> lIdentPA) {
        this.lIdentPA = lIdentPA;
    }

    /**
     * @return the lIdentRE
     */
    public ArrayList<Integer> getLIdentRE() {
        return lIdentRE;
    }

    /**
     * @param lIdentRE the lIdentRE to set
     */
    public void setLIdentRE(ArrayList<Integer> lIdentRE) {
        this.lIdentRE = lIdentRE;
    }

    /**
     * @return the lIdentRR
     */
    public ArrayList<Integer> getLIdentRR() {
        return lIdentRR;
    }

    /**
     * @param lIdentRR the lIdentRR to set
     */
    public void setLIdentRR(ArrayList<Integer> lIdentRR) {
        this.lIdentRR = lIdentRR;
    }

    /**
     * @return the lIdentRI
     */
    public ArrayList<Integer> getLIdentRI() {
        return lIdentRI;
    }

    /**
     * @param lIdentRI the lIdentRI to set
     */
    public void setLIdentRI(ArrayList<Integer> lIdentRI) {
        this.lIdentRI = lIdentRI;
    }

    /**
     * @return the lIdentRF
     */
    public ArrayList<Integer> getLIdentRF() {
        return lIdentRF;
    }

    /**
     * @param lIdentRF the lIdentRF to set
     */
    public void setLIdentRF(ArrayList<Integer> lIdentRF) {
        this.lIdentRF = lIdentRF;
    }

    /**
     * @return the lIdentRNF
     */
    public ArrayList<Integer> getLIdentRNF() {
        return lIdentRNF;
    }

    /**
     * @param lIdentRNF the lIdentRNF to set
     */
    public void setLIdentRNF(ArrayList<Integer> lIdentRNF) {
        this.lIdentRNF = lIdentRNF;
    }

    /**
     * @return the lIdentAC
     */
    public ArrayList<Integer> getLIdentAC() {
        return lIdentAC;
    }

    /**
     * @param lIdentAC the lIdentAC to set
     */
    public void setLIdentAC(ArrayList<Integer> lIdentAC) {
        this.lIdentAC = lIdentAC;
    }

    /**
     * @return the lIdentOB
     */
    public ArrayList<Integer> getLIdentOB() {
        return lIdentOB;
    }

    /**
     * @param lIdentOB the lIdentOB to set
     */
    public void setLIdentOB(ArrayList<Integer> lIdentOB) {
        this.lIdentOB = lIdentOB;
    }

    /**
     * @return the lIdentMR
     */
    public ArrayList<Integer> getLIdentMR() {
        return lIdentMR;
    }

    /**
     * @param lIdentMR the lIdentMR to set
     */
    public void setLIdentMR(ArrayList<Integer> lIdentMR) {
        this.lIdentMR = lIdentMR;
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object 
     */
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }
}


