package modelo;

import java.io.Serializable;
import java.util.Observable;
import javax.persistence.*;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.58D7DABE-337F-FB59-E354-70F739167AA2]
// </editor-fold> 
/**
 *
 * Clase ExcepcionCU, identifica a una <b>Excepcion</b>
 */
@Entity
@Table (name="exception CU")
public class ExcepcionCU extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.5586E3C5-C0FF-A34E-88EB-742263E15D3E]
    // </editor-fold>
    /**
     * Variable en la que se guarda la condición que tiene que suceder en la excepción
     */
    @Column (name="condition ")
    private String condicion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.FF50E08F-51E3-0A94-74FE-83C2CFA377D0]
    // </editor-fold>
    /**
     * Variable donde se guarda el valor de la cantidad de veces a realizar el trabajo
     */
    @Column (name="value ")
    private int valor;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.CF688141-1F10-B711-96B5-FF7217EC3AF3]
    // </editor-fold> 
    /**
     * Variable donde se guarda la unidad de la Excepcion
     */
    @Column (name="unit ")
    private String unidad;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.6AA80EE8-616B-D75E-6380-6DDC3846404D]
    // </editor-fold> 
    /**
     * Variable donde se guarda el comentario de la Excepcion.
     */
    @Column (name="comment")
    private String comentario;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.C95DD0D0-3DD9-20DC-AA08-0C4D000D62F4]
    // </editor-fold> 
    /**
     * Variable donde se guarda la terminacion.
     */
    @Column (name="termination")
    private String terminacion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.46E906C3-DF13-667B-214C-656E16C8CF3E]
    // </editor-fold> 
    /**
     * Variable donde se guarda la accion
     */
    @Column (name="action ")
    private String accion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.31B06DD2-1543-0B3E-6DA3-82EFA8444ED2]
    // </editor-fold> 
    /**
     * Variable donde se guarda la acticavion de la Accion del sistema
     */
    @Column (name="is system action")
    private boolean AccionSistema;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.C2B13A72-78E8-6DB0-C371-4090888B9C74]
    // </editor-fold> 
    /**
     * Variable donde se guarda la activacion del actor
     */
    @Column (name="is actor action")
    private boolean AccionActor;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.F4E84516-80DB-5E35-E875-F799E8640233]
    // </editor-fold> 
    /**
     * Variable donde se guarda la activacion Inclusion y la Exclusion
     */
    @Column (name="is system IE")
    private boolean InclusionExtension;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.81F342B9-6783-30AE-A932-2B77E4B0BD92]
    // </editor-fold> 
    /**
     * Variable donde se guarda el actor
     */
    @Column (name="actor")
    private String Actor;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.45E02B94-A65B-E82F-C22A-E2480270A425]
    // </editor-fold> 
    /**
     * Variable donde se guarda la inclusion y la exclusion
     */
    @Column (name="IE")
    private String IE;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.490E9D4F-4F36-6032-1B8E-285ADDEF4A50]
    // </editor-fold> 
    /**
     * Constructor de la ExcepcionCU
     */
    public ExcepcionCU () {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E8EFB089-F299-ED16-60F3-5D88DF2009FE]
    // </editor-fold> 
    /**
     * Metodo que devuelve la activacion o no de la accionActor
     * @return AccionActor
     */
    public boolean getAccionActor () {
        return AccionActor;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.51C04941-58DC-0788-B4F4-FCA43454FB6C]
    // </editor-fold> 
    /**
     * Metodo que añade la activacion o no de la AccionActor
     * @param val 
     */
    public void setAccionActor (boolean val) {
        this.AccionActor = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.80DC025A-D522-108B-94B0-A2D8EDBB36AA]
    // </editor-fold> 
    /**
     * Metodo que devuelve la activacion o no de la accion del sistema
     * @return AccionSistema
     */
    public boolean getAccionSistema () {
        return AccionSistema;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.78B1CAFF-165A-4DBE-184B-CA6DAEC161B9]
    // </editor-fold> 
    /**
     * Metodo que añade la activacion o no de la accion sistema
     * @param val 
     */
    public void setAccionSistema (boolean val) {
        this.AccionSistema = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.4812BA45-FA76-91DD-C6C2-CB1B943BCA70]
    // </editor-fold> 
    /**
     * Metodo que devuelve el nombre del actor
     * @return Actor
     */
    public String getActor () {
        return Actor;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.512EE225-F235-E915-BE2D-E40D7D104EE8]
    // </editor-fold> 
    /**
     * Metodo que añade el nombre del actor
     * @param val 
     */
    public void setActor (String val) {
        this.Actor = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.76CAE2EB-1EF5-117C-CBF1-E6BACFC82E85]
    // </editor-fold> 
    /**
     * Metodo que devuelve la inclusion/exclusion
     * @return 
     */
    public String getIE () {
        return IE;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.D59527C3-19C6-2D36-24D8-5C47F305DAB3]
    // </editor-fold> 
    /**
     * Metodo que añade la inclusion/exclusion
     * @param val 
     */
    public void setIE (String val) {
        this.IE = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F1E7DDB2-7FA4-4C28-5C12-60B90FBA6FD2]
    // </editor-fold> 
    /**
     * Metodo que devuelve la activacion de la incluion/exclusion
     * @return InclusionExtension
     */
    public boolean getInclusionExtension () {
        return InclusionExtension;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.8E17CF6C-C72A-ABB4-C67F-1C77D1F04CA7]
    // </editor-fold> 
    /**
     * Metodo que añade la activacion de la incluion/exclusion
     * @param val 
     */
    public void setInclusionExtension (boolean val) {
        this.InclusionExtension = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.7B64FE0E-2092-C24C-B890-82C3A4CA944E]
    // </editor-fold> 
    /**
     * Metodo que devuelve la accion
     * @return accion
     */
    public String getAccion () {
        return accion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.448F0F57-D18B-62D2-0C10-D50C29A0F8F3]
    // </editor-fold> 
    /**
     * Metodo que añade la accion
     * @param val 
     */
    public void setAccion (String val) {
        this.accion = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E3603689-EB5C-864A-84F6-C564480DC938]
    // </editor-fold> 
    /**
     * Metodo que devuelve el comentario
     * @return comentario
     */
    public String getComentario () {
        return comentario;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.85099BBD-10C6-052B-24D8-A8152671794B]
    // </editor-fold> 
    /**
     * Metodo que añade el comentario a la ExcepcionCU
     * @param val 
     */
    public void setComentario (String val) {
        this.comentario = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.16BFBDCD-DDA9-D4C0-B1AB-76738AEFE118]
    // </editor-fold> 
    /**
     * Metodo que devuelve la condicion
     * @return condicion
     */
    public String getCondicion () {
        return condicion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.62C0E4CE-DC89-FE32-8E0E-41C9F780C216]
    // </editor-fold> 
    /**
     * Metodo que añade la condicion
     * @param val 
     */
    public void setCondicion (String val) {
        this.condicion = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.CFCF4FED-A3FB-8C49-C058-FE3E7ADE0E7A]
    // </editor-fold> 
    /**
     * Metodo que devuelve la terminacion
     * @return terminacion
     */
    public String getTerminacion () {
        return terminacion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F31E2C07-6838-4BAB-97C3-5447F6868ABB]
    // </editor-fold> 
    /**
     * Metodo que añade la terminacion
     * @param val 
     */
    public void setTerminacion (String val) {
        this.terminacion = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F5103E38-0F76-FE19-9F76-C47FA428EF0E]
    // </editor-fold> 
    /**
     * Metodo que devuelve la unidad
     * @return unidad
     */
    public String getUnidad () {
        return unidad;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F8127084-08F6-CFDC-91F0-438D26100134]
    // </editor-fold> 
    /**
     * Metodo que añade el valor unidad a la Excepcion
     * @param val 
     */
    public void setUnidad (String val) {
        this.unidad = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.338BCCBB-262C-8919-8731-32C385058A1B]
    // </editor-fold> 
    /**
     * Metodo que devuelve el valor de la ExcepcionCu
     * @return valor
     */
    public int getValor () {
        return valor;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.C03C9531-4829-DBDE-FBE2-C051DE6A1F2C]
    // </editor-fold> 
    /**
     * Metodo que añade un valor a la ExcepcionCU
     * @param val 
     */
    public void setValor (int val) {
        this.valor = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve solo la parte cadena del identificador
     * @return la cadena id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que inserta solo la parte cadena del identificador
     * @param id cadena id a insertar
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Metodo que devuelve solo la parte número del identificador
     * @return el entero id
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que inserta solo la parte número del identificador
     * @param id_n entero id a insertar
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve el identificador completo
     * @return el identificador
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que inserta el identificador completo
     * @param ident identificador completo a insertar
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object 
     */
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

}

