package modelo;

import java.io.File;
import java.io.Serializable;
import java.util.Observable;
import javax.persistence.*;

/**
 * Clase FicheroGrafico, sirve para subir algun <b>Fichero Grafico</b>
 */

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.C5F3FBB5-DE57-764F-FDE7-763D4E06156A]
// </editor-fold>
@Entity
@Table (name="Fichero gráfico")
public class FicheroGrafico extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.D8BAA85A-C777-E9D2-54A5-36ED9F1522EE]
    // </editor-fold>
    /**
     * Con esta variable identificamos el nombre.
     */
    @Column(name="name File")
    private String nombre;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.0B264960-508B-ABDF-8C56-A4E2065092AB]
    // </editor-fold> 
    /**
     * Con esta variable identificamos la ruta del fichero
     */
    @Column(name="file")
    private File fichero;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.EF7F8C43-9E7B-07F4-D5F2-4C059885A28E]
    // </editor-fold> 
    /**
     * Con esta variable identificamos el comentario.
     */
    @Column(name="comment")
    private String comentarios;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.21F521CE-49B3-C44E-77BE-3D85928B5763]
    // </editor-fold> 
    /**
     * Metodo del Construcotr FicheroGrafico
     */
    public FicheroGrafico () {
    }   

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.C867B2BD-A104-44DD-C45A-1A045E298593]
    // </editor-fold> 
    /**
     * Devuelve el String comentario
     * @return comentarios
     */
    public String getComentarios () {
        return comentarios;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.500D5D8F-4954-1C0C-17DB-CA5F89E813D3]
    // </editor-fold> 
    /**
     * Añade un comentario al FicheroGrafico
     * @param val 
     */
    public void setComentarios (String val) {
        this.comentarios = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.D19358E9-3049-909C-6122-9D1DDBD6F4D8]
    // </editor-fold> 
    /**
     * Devuelve el nombre
     * @return nombre
     */
    public String getNombre () {
        return nombre;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.60BBEA36-6C90-060A-B9B1-1E8C41A054F0]
    // </editor-fold> 
    /**
     * Añade el nombre al FicheroGrafico
     * @param val 
     */
    public void setNombre (String val) {
        this.nombre = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Devuelve el fichero al FicheroGrafico
     * @return fichero
     */
    public File getFichero() {
        return fichero;
    }

    /**
     * Añade el fichero al FicheroGrafico
     * @param fichero
     */
    public void setFichero(File fichero) {
        this.fichero = fichero;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Devuelve el Id
     * @return the id
     */
    public String getId() {
        return id;
    }

    /**
     * Añade el Id al FicheroGrafico
     * @param id the id to set
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Devuelve el Id_n
     * @return id_n
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Añade el id_n al FicheroGrafico
     * @param id_n the id_n to set
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Devuelve el Ident
     * @return the ident
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Añade el Ident al FicheroGrafico
     * @param ident the ident to set
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

}

