package modelo;

import java.io.Serializable;
import java.util.ArrayList; 
import java.util.Observable;
import javax.persistence.*;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.06BE5A03-C50B-AD06-8DB6-73D6657629CE]
// </editor-fold> 
/**
 *
 * Clase Objetivo, identifica a un <b>objetivo</b>
 */
@Entity
@Table (name="Objective")
public class Objetivo extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.6F0E2358-65BE-EED8-E018-7D78F2E5DE73]
    // </editor-fold> 
    /**
     * Variable que guarda el nombre del objetivo
     */
    @Column(name="name Obj")
    private String nombre;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.FE2CAD26-EA4C-9941-7A7C-AE2425EFBDFD]
    // </editor-fold> 
    /**
     * Variable que guarda la descripcion del objetivo
     */
    @Column(name="description")
    private String descripcion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.923FCD3C-179E-B8D8-8D71-5E58777C78F1]
    // </editor-fold> 
    /**
     * Varible donde guarda la importancia
     */
    @Column(name="importance")
    private String importancia;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.F7C66749-8DFB-6F98-AF42-4FF3F702C8E9]
    // </editor-fold> 
    /**
     * Variable donde guarda la urgencia
     */
    @Column(name="urgency")
    private String urgencia;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.CC3A261B-7648-A3A4-58E8-74D5D4033AFB]
    // </editor-fold> 
    /**
     * Variable donde guarda el estado
     */
    @Column(name="state development")
    private String estado;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.E47B1EF1-DBE3-59BB-C57C-4C62624319CB]
    // </editor-fold> 
    /**
     * Variable dodne guarda la estabilidad
     */
    @Column(name="stability")
    private String estabilidad;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.8298BF44-49C7-E64A-8FB2-4C861E7D5C6D]
    // </editor-fold> 
    /**
     * Array de subobjetivos
     */
    @OneToMany
    private ArrayList<Subobjetivo> mSubobjetivo=new ArrayList();

    /**
     * Array de destino
     */
    @OneToMany
    private ArrayList<String> mDestino = new ArrayList();

    /**
     * Array de lista
     */
    @OneToMany
    private ArrayList<String> mOrigen = new ArrayList();

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.FCA91A00-2D4B-7A63-90AD-F07A14763CFC]
    // </editor-fold> 
    /**
     * Constructor de la clase de objetivo
     */
    public Objetivo () {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.8262B902-B3FC-86DD-F4C7-77C575372F6D]
    // </editor-fold> 
    /**
     * Metodo que devuelve la descripcion
     * @return descripcion
     */
    public String getDescripcion () {
        return descripcion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.01FAB6C6-8015-D49D-D1C9-E27D8D770054]
    // </editor-fold> 
    /**
     * Metodo añade una descripcion
     * @param val 
     */
    public void setDescripcion (String val) {
        this.descripcion = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.758A3224-4825-C4FC-56A4-D3DD4EED06D1]
    // </editor-fold> 
    /**
     * Metodo que devuelve la estabilidad
     * @return estabilidad
     */
    public String getEstabilidad () {
        return estabilidad;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F2331D4F-0840-DB0C-9A6A-5980AFA243D2]
    // </editor-fold> 
    /**
     * Metodo que añade la estabilidad
     * @param val 
     */
    public void setEstabilidad (String val) {
        this.estabilidad = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.FEC57866-49B2-83BB-5E0E-37B74266CB09]
    // </editor-fold> 
    /**
     * Metodo que devuelve el estado
     * @return estado
     */
    public String getEstado () {
        return estado;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.EA89912C-D6B1-5B51-ED96-67D76E1D9E03]
    // </editor-fold> 
    /**
     * Metodo que añade el estado
     * @param val 
     */
    public void setEstado (String val) {
        this.estado = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.0EA4FF8B-E172-6B62-7C88-8D3EC58912B5]
    // </editor-fold> 
    /**
     * Metodo que devuelve la importancia
     * @return importancia
     */
    public String getImportancia () {
        return importancia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.655D18CC-CEF6-BBC7-6FBF-C0A4F9F12465]
    // </editor-fold> 
    /**
     * Metodo que añade la importancia
     * @param val 
     */
    public void setImportancia (String val) {
        this.importancia = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.720FD59B-30CA-67FD-380C-A9599AE72AD6]
    // </editor-fold> 
    /**
     * Metodo que devuelve el array de subobjetivo
     * @return mSubobjetivo
     */
    public ArrayList<Subobjetivo> getSubobjetivo () {
        return mSubobjetivo;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.BE4A46F2-F4A4-72BE-AA49-D1B2979E8848]
    // </editor-fold> 
    /**
     * Metodo que añade el array de subobjetivo
     * @param val 
     */
    public void setSubobjetivo (ArrayList<Subobjetivo> val) {
        this.mSubobjetivo = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.0EC5C68F-C259-1B39-C288-68C5CDB64775]
    // </editor-fold> 
    /**
     * Metodo que devuelve el nombre
     * @return nombre
     */
    public String getNombre () {
        return nombre;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.076D30EE-66DE-3BD4-7FF0-0EEC09DA18CD]
    // </editor-fold> 
    /**
     * Metodo que devuelve el nombre
     * @param val 
     */
    public void setNombre (String val) {
        this.nombre = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.4BA55417-33DF-D02E-A1AC-F94FA148C990]
    // </editor-fold> 
    /**
     * Metodo que devuelve la urgencia
     * @return urgencia
     */
    public String getUrgencia () {
        return urgencia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.92046E33-CC21-238C-9AE6-7DC0E8B5A85B]
    // </editor-fold> 
    /**
     * Metodo que devuelve la urgencia
     * @param val 
     */
    public void setUrgencia (String val) {
        this.urgencia = val;
        this.setChanged();
        this.notifyObservers();
    }
    /**
     *
     */
    private ArrayList<Integer> lIdentSO = new ArrayList();

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.F9ADAC43-767C-3717-FCF3-261C0F66558B]
    // </editor-fold> 
    /**
     * Metodo que crea y devuelve un subobjetivo
     * @param Id
     * @param Nombre
     * @param descripcion
     * @param importancia
     * @param urgencia
     * @param estado
     * @param estabilidad
     * @return subobjetivo
     */
    public Subobjetivo nuevoSubObj (int Id, String Nombre,String descripcion, String importancia,String urgencia, String estado, String estabilidad){

     //// Creo la instancia
        Subobjetivo auxSObj=new Subobjetivo();
        //// Asigno los valores a los atributos
        auxSObj.setId("SUBO");
        auxSObj.setId_n(Id);
        auxSObj.setIdent(auxSObj.getId()+String.valueOf(Id));
        auxSObj.setNombre(Nombre);
        auxSObj.setDescripcion(descripcion);
        auxSObj.setEstabilidad(estabilidad);
        auxSObj.setEstado(estado);
        auxSObj.setUrgencia(urgencia);
        auxSObj.setImportancia(importancia);
        //// Enlazo el Actor a la lista de Actores que tiene el documento
        this.getSubobjetivo().add(auxSObj);
        //persist(auxSObj);
        return auxSObj;

    }

    /**
     * Metodo que devuelve el array destino
     * @return the mDestino
     */
    public ArrayList<String> getMDestino() {
        return mDestino;
    }

    /**
     * Metodo que añade el array destino
     * @param mDestino the mDestino to set
     */
    public void setMDestino(ArrayList<String> mDestino) {
        this.mDestino = mDestino;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve el array origen
     * @return the mOrigen
     */
    public ArrayList<String> getMOrigen() {
        return mOrigen;
    }

    /**
     * Metodo que añade el array origen
     * @param mOrigen the mOrigen to set
     */
    public void setMOrigen(ArrayList<String> mOrigen) {
        this.mOrigen = mOrigen;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve el ID
     * @return the id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que añade el Id
     * @param id the id to set
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Metodo que devuelve el id_n
     * @return the id_n
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que añade el id_n
     * @param id_n the id_n to set
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve el Ident
     * @return the ident
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que añade el Ident
     * @param ident the ident to set
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object 
     */
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

    /**
     * @return the lIdentMR
     */
    public ArrayList<Integer> getLIdentSO() {
        return lIdentSO;
    }

    /**
     * @param lIdentMR the lIdentMR to set
     */
    public void setLIdentSO(ArrayList<Integer> lIdentSO) {
        this.lIdentSO = lIdentSO;
    }

}

