/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package modelo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Observable;
import javax.persistence.*;

/**
 *
 * Clase Organizacion, identifica a una <b>organización</b>.
 */
@Entity
@Table (name="Organizacion")
public class Organizacion extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker ">
    // #[regen=yes,id=DCE.4105E8E0-8601-8404-42AB-98F7DCCEEF43]
    // </editor-fold>
    /**
     * Con esta variable identificamos el nombre.
     */
    @Column(name="name Organization")
    private String nombre;
    /**
     * Con esta variable identificamos la dirección.
     */
    @Column(name="direction")
    private String direccion;
    /**
     * Con esta variable identificamos el teléfono.
     */
    @Column(name="telephone")
    private String telefono;
    /**
     * Con esta variable identificamos el fax.
     */
    @Column(name="fax")
    private String fax;
    /**
     * Con esta variable identificamos los participantes.
     */
    @OneToMany
    private ArrayList<String> mParticipantes = new ArrayList();
    /**
     * Con esta variable identificamos el comentario.
     */
    @Column(name="comment")
    private String comentario;

    /**
     * Metodo que devuelve solo la parte cadena del identificador
     * @return la cadena id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que inserta solo la parte cadena del identificador
     * @param id cadena id a insertar 
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Metodo que devuelve solo la parte número del identificador
     * @return el entero id
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que inserta solo la parte número del identificador
     * @param id_n entero id a insertar
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve el identificador completo
     * @return el identificador
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que inserta el identificador completo
     * @param ident identificador completo a insertar
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    

    /**
     * Metodo que devuelve el nombre
     * @return el nombre
     */
    public String getNombre() {
        return nombre;
    }

    /**
     * Metodo que añade el nombre
     * @param val es un string que representa el nombre
     */
    public void setNombre(String val) {
        this.nombre = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve la direccion
     * @return la direccion
     */
    public String getDireccion() {
        return direccion;
    }

    /**
     * Metodo que añade la direccion
     * @param val es un string que representa la direccion
     */
    public void setDireccion(String val) {
        this.direccion = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve el telefono
     * @return el telefono
     */
    public String getTelefono() {
        return telefono;
    }

    /**
     * Metodo que añade el telefono
     * @param val es un string que representa el telefono
     */
    public void setTelefono(String val) {
        this.telefono = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve el fax
     * @return el fax
     */
    public String getFax() {
        return fax;
    }

    /**
     * Metodo que añade el fax
     * @param val es un strign que representa el fax
     */
    public void setFax(String val) {
        this.fax = val;
        this.setChanged();
        this.notifyObservers();
    }
    
    /**
     * Metodo que devuelve el comentario
     * @return el comentario
     */
    public String getComentario() {
        return comentario;
    }

    /**
     * Metodo que añade participantes a la organizacion
     * @param mParticipantes es un string que es un participante
     */
    public void setMParticipantes(ArrayList<String> mParticipantes) {
        this.setMParticipantes(mParticipantes);
    }

    /**
     * Metodo que devuelve un participante
     * @return el mParticipantes
     */
    public ArrayList<String> getMParticipantes() {
        return mParticipantes;
    }

    /**
     * Metodo que añade el comentario
     * @param comentario es un string que representa el comentario
     */
    public void setComentario(String comentario) {
        this.comentario = comentario;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object 
     */
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }
}
