package modelo;

import java.io.Serializable;
import java.util.Observable;
import javax.persistence.*;


// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.9193488B-E00D-2332-4296-EEE0EE6FB64B]
// </editor-fold>
/**
 *
 * Clase parrafo, identifica a un <b>parrafo</b>.
 */
@Entity
@Table (name = "paragraph")
public class Parrafo extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.B54F8186-8D94-D0D4-B28F-0ECCB64D9677]
    // </editor-fold>
    /**
     * Con esta variable guardamos el nombre
     */
    @Column (name="name paragraph")
    private String nombre;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.2CBB5A9E-05F5-74D2-3F70-7E8F3FA36817]
    // </editor-fold>
    /**
     * Con esta variable guardo el texto que quieras guardar
     */
    @Column (name="text")
    private String texto;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.72E96DC5-563E-3F34-6BDF-540A6A5E68BA]
    // </editor-fold>
    /**
     * Con esta variable guardo el tipo 
     */
    @Column (name="type")
    private boolean tipo;


    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.13B58739-7023-1709-AB26-7D75F4CC047D]
    // </editor-fold>
    /**
     * Con esta variable algun comentario sobre el parrafo
     */
    @Column (name="comment")
    private String comentarios;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.D7B7E184-93E2-95E1-F744-E8AAC4788E15]
    // </editor-fold> 
    /**
     * Constructor de la clase
     */
    public Parrafo () {
    }


    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.07E3EC31-FCE3-AFE2-5385-A3D1313D49D5]
    // </editor-fold> 
    /**
     * Metodo que devuelve el comentario
     * @return el comentario
     */
    public String getComentarios () {
        return comentarios;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.2C598A36-D176-E6A2-25AE-EAB17A4D92F1]
    // </editor-fold> 
    /**
     * Metodo que añade el comentario
     * @param val es un string que representa el comentario
     */
    public void setComentarios (String val) {
        this.comentarios = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.80AF8B64-D7F7-BC28-6348-5D2D0996B8AF]
    // </editor-fold> 
    /**
     * Metodo que devuelve el nombre
     * @return el nombre
     */
    public String getNombre () {
        return nombre;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1C65423B-ED7D-CDAC-73C5-26AE2F331FEC]
    // </editor-fold>
    /**
     * Metodo que añade el nombre
     * @param val es un string que representa el nombre
     */
    public void setNombre (String val) {
        this.nombre = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.32EF1997-F0D1-165F-193B-D442111BA494]
    // </editor-fold>
    /**
     * Metodo que añade el texto
     * @return el texto
     */
    public String getTexto () {
        return texto;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.614BEF9F-05A3-6B74-7308-B2E1BD7F9715]
    // </editor-fold>
    /**
     * Metodo que añade el texto 
     * @param val es un string que representa el texto
     */
    public void setTexto (String val) {
        this.texto = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.09DECCBA-9D08-9ED2-21CB-1BD4F5892B81]
    // </editor-fold>
    /**
     * Metodo que devuelve si es tipo o no
     * @return si es tipo
     */
    public boolean getTipo () {
        return tipo;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.16F238AC-2BB0-6855-584C-08A42488DDA2]
    // </editor-fold>
    /**
     * Metodo que añade si es tipo o no
     * @param val es un booleano que representa si es tipo
     */
    public void setTipo (boolean val) {
        this.tipo = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve solo la parte cadena del identificador
     * @return la cadena id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que inserta solo la parte cadena del identificador
     * @param id cadena id a insertar 
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Metodo que devuelve solo la parte número del identificador
     * @return el entero id
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que inserta solo la parte número del identificador
     * @param id_n entero id a insertar
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve el identificador completo
     * @return el identificador
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que inserta el identificador completo
     * @param ident identificador completo a insertar
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object 
     */
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

}

