package modelo;

import java.io.Serializable;
import java.util.Observable;
import javax.persistence.*;


// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.6F6A90A6-254D-CAE4-DD4A-12C8BBF9C1C3]
// </editor-fold>
/**
 *
 * Clase participante, identifica a un <b>participante</b>.
 */
@Entity
@Table (name = "participant")
public class Participante extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.8F756338-963E-1622-E43A-F9C8B507A4D9]
    // </editor-fold>
    /**
     * Con esta variable guardo el nombre
     */
    @Column (name="name participant")
    private String nombre;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.070FADDC-9656-D9A2-6F4C-448CDD4BB352]
    // </editor-fold>
    /**
     * Con esta variable guardo el rol
     */
    @Column (name="rol")
    private String rol;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.F2EC1AB5-F8E0-4A1F-A72E-ACF7051CCFC1]
    // </editor-fold>
    /**
     * Con esta variable guardo el nombre de la organizacion
     */
    @Column (name="organization")
    private String orga;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.48DAC67D-A83A-2215-8D73-8387C5E5AAE4]
    // </editor-fold>
    /**
     * Con esta variable booleana comprobamos si es cliente
     */
    @Column (name="is client")
    private boolean esCliente;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.D85662EA-8C60-D79F-60DB-A2BA751AF259]
    // </editor-fold>
    /**
     * Con esa variable booleana comprobamos si es desarrollador
     */
    @Column (name="is developer")
    private boolean esDesarrollador;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.0784BE21-D38D-F90A-D400-027F4BCC3E90]
    // </editor-fold>
    /**
     * Con esta variable booleana comprobamos si es usuario
     */
    @Column (name="is user")
    private boolean esUsuario;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.EDF14E3C-6CA8-2498-CB74-265E29DCDAC2]
    // </editor-fold> 
    /**
     * Constructor de la clase
     */
    public Participante () {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.D334628E-5859-ED7A-3336-E2CE3C20E645]
    // </editor-fold> 
    /**
     * Metodo que devuelve un booleano para saber si es cliente o no 
     * @return un booleano de si es cliente
     */
    public boolean getEsCliente () {
        return esCliente;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.BC29C13A-760C-325A-591D-41857B257454]
    // </editor-fold> 
    /**
     * Metodo que añade si es cliente o no
     * @param val es un booleano que representa si es un cliente o no
     */
    public void setEsCliente (boolean val) {
        this.esCliente = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.64063425-9770-90D9-4E64-8EE986D2AE14]
    // </editor-fold> 
    /**
     * Metodo que devuelve si es un desarrollador o no
     * @return si es un desarrollador o no
     */
    public boolean getEsDesarrollador () {
        return esDesarrollador;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.97F9070A-E8E9-D2CD-44F3-28E029F40816]
    // </editor-fold> 
    /**
     * Metodo que añade un booleano si es desarrollador o no
     * @param val es un booleano que representa si es un desarrollador
     */
    public void setEsDesarrollador (boolean val) {
        this.esDesarrollador = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.A84ACA07-D35B-D493-9B07-A810E4D3E313]
    // </editor-fold> 
    /**
     * Metodo que devuelve si es un usuario o no
     * @return si es un usuario
     */
    public boolean getEsUsuario () {
        return esUsuario;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.A47D3758-C52E-D3E1-1D33-07CD7B56FD4C]
    // </editor-fold> 
    /**
     * Metodo que añade si es un usario o no
     * @param val es un booleano que represetna si es un usuario o no
     */
    public void setEsUsuario (boolean val) {
        this.esUsuario = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.6CA6921A-E73F-9A9B-88D3-25194C48A241]
    // </editor-fold> 
    /**
     * Metodo que devuelve el nombre
     * @return el nombre
     */
    public String getNombre () {
        return nombre;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.40EC579F-6DB3-0F63-D4E0-9BB454299A8B]
    // </editor-fold> 
    /**
     * Metodo que añade el nombre
     * @param val es un string que representa el nombre
     */
    public void setNombre (String val) {
        this.nombre = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1B01DCF2-BBBC-77F4-DED4-DE4FB07170FA]
    // </editor-fold> 
    /**
     * Metodo que devuelve la organizacion
     * @return la organizacion
     */
    public String getOrga () {
        return orga;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.957CFD7F-98DD-39B6-3B7F-2F184558E426]
    // </editor-fold> 
    /**
     * Metodo que añade la organizacion
     * @param val es un string que representa la organizacion
     */
    public void setOrga (String val) {
        this.orga = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.672AB225-47CA-FBAB-EC53-46DFB2ABF9FD]
    // </editor-fold> 
    /**
     * Metodo que devuelve el rol
     * @return el rol
     */
    public String getRol () {
        return rol;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.C12F4537-942D-10BF-7880-006E68BF93EB]
    // </editor-fold> 
    /**
     * Metodo que añade el rol
     * @param val es un string que representa el rol
     */
    public void setRol (String val) {
        this.rol = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve solo la parte cadena del identificador
     * @return la cadena id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que inserta solo la parte cadena del identificador
     * @param id cadena id a insertar 
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Metodo que devuelve solo la parte número del identificador
     * @return el entero id
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que inserta solo la parte número del identificador
     * @param id_n entero id a insertar
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve el identificador completo
     * @return el identificador
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que inserta el identificador completo
     * @param ident identificador completo a insertar
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object 
     */
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

}

