package modelo;

import java.io.Serializable;
import java.util.ArrayList; 
import java.util.Observable;
import javax.persistence.*;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.A4D5F0CD-9042-7332-B5DD-FDA9D643D990]
// </editor-fold>
/**
 *
 * Clase RequisitoInformacion, identifica a un <b>Requisito de informacion</b>.
 */
@Entity
@Table (name="information requirement")
public class RequisitoInformacion extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.5CFD3E03-F9AD-1324-39F8-3EB7F8419AF0]
    // </editor-fold>
    /**
     * Con esta variable guardamos el nombre
     */
    @Column (name="name RI")
    private String Nombre;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.39E96CE9-9811-798A-1594-AE95E9F9FCD1]
    // </editor-fold>
    /**
     * Con esta variable guardamos el concepto
     */
    @Column (name="concept")
    private String concepto;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.2531251F-E80A-5B8C-BA55-96D2F6FFF5E7]
    // </editor-fold>
    /**
     * Con esta variable guardamos el valor max
     */
    @Column (name="value max")
    private int valorMax;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.F64A2CF3-9F03-CAA5-4FCB-3A7796E0183A]
    // </editor-fold>
    /**
     * Con esta variable guardamos la unidad del valor max
     */
    @Column (name="unit t max")
    private String unidadTMax;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.2AC42E74-FEFE-2901-1B16-3BA2326DA8D1]
    // </editor-fold>
    /**
     * Con esta variable guardamos el valor medio
     */
    @Column (name="value med")
    private int valorMe;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.E980BE90-795C-1B0B-E687-4B4B5980B8FF]
    // </editor-fold>
    /**
     * Con esta variable guardamos la unidad del valor medio
     */
    @Column (name="unit t med")
    private String unidadTMe;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.F78F760F-F4EE-071B-98AD-07CAB796C6FB]
    // </editor-fold>
    /**
     * Con esta variable guardamos el numero max
     */
    @Column (name="num max")
    private int numeroMax;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.CF0D4BD9-8A93-264F-F7C8-9A6309976FCD]
    // </editor-fold>
    /**
     * Con esta variable guardamos el numero medio
     */
    @Column (name="num med")
    private int numeroMed;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.85437887-B646-8E44-F1C0-743E1B86D313]
    // </editor-fold>
    /**
     * Con esta variable guardamos la importancia
     */
    @Column (name="importance")
    private String importancia;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.17A551F7-1E2A-9EBC-C157-EC12580226AA]
    // </editor-fold>
    /**
     * Con esta variable guardamos el estado
     */
    @Column (name="state development")
    private String estado;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.09F9D4FF-98CE-B4B4-DAA0-5064FCB4FABC]
    // </editor-fold>
    /**
     * Con esta variable guardamos la estabilidad
     */
    @Column (name="stability")
    private String estabilidad;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.7FD7075B-41F0-4BE0-C7CB-77F11CF45628]
    // </editor-fold>
    /**
     * Con esta variable guardamos la urgencia
     */
    @Column (name="urgency")
    private String urgencia;

    /**
     * Con esta variable guardamos el array del destino
     */
    @OneToMany
    private ArrayList<String> mDestino = new ArrayList();

    /**
     * Con esta variable guardamos el array del origen
     */
    @OneToMany
    private ArrayList<String> mOrigen = new ArrayList();

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.BCA83CEA-F29F-88EB-1C7E-6B3E5A297AE6]
    // </editor-fold>
    /**
     * Con esta variable guardamos el array de datos especificos
     */
    @OneToMany
    private ArrayList<DatoEspecifico> mDatoEspecifico=new ArrayList();

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.700AA8F5-54D2-922A-FDED-B937418B999C]
    // </editor-fold>
    /**
     * Constructor de la calse
     */
    public RequisitoInformacion () {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.D27D5497-5B46-485E-5791-7C0C92FE8F0D]
    // </editor-fold>
    /**
     * Metodo que devuelve el nombre
     * @return el nombre
     */
    public String getNombre () {
        return Nombre;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.5A6BB83A-69AC-3818-F086-1D6CA0C50E74]
    // </editor-fold>
    /**
     * Metodo qye añade el nombre
     * @param val es un string que representa el nombre
     */
    public void setNombre (String val) {
        this.Nombre = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1431C6E5-9C38-44E4-9615-06ECCC7B4A8C]
    // </editor-fold>
    /**
     * Metodo que devuelve el concepto
     * @return el concepto
     */
    public String getConcepto () {
        return concepto;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.02209568-FD7B-AB52-0977-999A21AFCD5E]
    // </editor-fold>
    /**
     * Metodo que añade el concepto
     * @param val es una string que representa el concepto
     */
    public void setConcepto (String val) {
        this.concepto = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.54A82A6D-7531-BB70-359E-D3597F00D666]
    // </editor-fold>
    /**
     * Metodo que devuelve la estabilidad
     * @return la estabilidad
     */
    public String getEstabilidad () {
        return estabilidad;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.0B74FA9E-3194-A555-D319-FF3DA00818F0]
    // </editor-fold>
    /**
     * Metodo que añade la estabilidad
     * @param val es un string que represetta la estabilidad
     */
    public void setEstabilidad (String val) {
        this.estabilidad = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.822CD530-7FFA-75FD-AB96-546CD9281452]
    // </editor-fold>
    /**
     * Metodo que devuelve el estado
     * @return el estado
     */
    public String getEstado () {
        return estado;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.9463114C-6BD8-859B-7510-594453ABAF16]
    // </editor-fold>
    /**
     * Metodo que añade el estado
     * @param val es un string que devuelve el estado
     */
    public void setEstado (String val) {
        this.estado = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.FE7C204A-A9DE-99D0-37E6-13D593B9BD2A]
    // </editor-fold>
    /**
     * Metodo que devuelve la importancia
     * @return la importancia
     */
    public String getImportancia () {
        return importancia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.98329F7D-46C2-5A81-2622-94651BDE8297]
    // </editor-fold>
    /**
     * Metodo que añade la importancia
     * @param val es un string que representa la importancia
     */
    public void setImportancia (String val) {
        this.importancia = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.6AAD19A7-07AB-2507-4C5E-B035116DA232]
    // </editor-fold>
    /**
     * Metodo que devuelve un array de datos especificos
     * @return datos especifico
     */
    public ArrayList<DatoEspecifico> getDatoEspecifico () {
        return mDatoEspecifico;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.0F3BC1EC-7DFC-B7FE-20CD-95E3CD0591F0]
    // </editor-fold>
    /**
     * Metodo que añade un dato especifico
     * @param val es un array de datos especifico
     */
    public void setDatoEspecifico (ArrayList<DatoEspecifico> val) {
        this.mDatoEspecifico = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.2C22438C-C22B-4324-07E5-3BACDEFFFE5A]
    // </editor-fold>
    /**
     * Metodo que devuelve el numero maximo
     * @return el numero maximo
     */
    public int getNumeroMax () {
        return numeroMax;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.95DEB023-42B7-6E72-3F88-B1C33410F1E1]
    // </editor-fold>
    /**
     * Metodo que añade un numero maximo
     * @param val es una entero que representa al numero maximo
     */
    public void setNumeroMax (int val) {
        this.numeroMax = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.24965799-CB0C-147E-90BB-E6D74FB58844]
    // </editor-fold>
    /**
     * Metodo que devuelve un numero medio
     * @return un numero medio
     */
    public int getNumeroMe () {
        return numeroMed;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.767F9603-3C54-85C6-4EF5-55F802108678]
    // </editor-fold>
    /**
     * Metodo que añade el numero medio
     * @param val es un entero que representa el numero medio
     */
    public void setNumeroMe (int val) {
        this.numeroMed = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.B45B78C8-A803-6052-1B7B-3BCDB4D44837]
    // </editor-fold>
    /**
     * Metodo que devuelve la unidad de t max
     * @return la unidad maxima
     */
    public String getUnidadTMax () {
        return unidadTMax;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F9A2F01C-B267-ABB8-76CC-68023A352ECC]
    // </editor-fold>
    /**
     * Metodo que añade la unidad de t max
     * @param val es un string que representa la unidad de t max
     */
    public void setUnidadTMax (String val) {
        this.unidadTMax = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E81A2209-F154-071F-1865-B05A422028E1]
    // </editor-fold>
    /**
     * Metodo que devuelve la unidad de t medio
     * @return la unidad de t medio
     */
    public String getUnidadTMe () {
        return unidadTMe;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F2A02E8A-21DC-3E78-09DC-B811D36F3F62]
    // </editor-fold>
    /**
     * Metodo qye añade la unidad de t medio
     * @param val es un string que representa la unidad de t medio
     */
    public void setUnidadTMe (String val) {
        this.unidadTMe = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.78031577-CE0A-D219-3F5A-138B5E6855A7]
    // </editor-fold>
    /**
     * Metodo que devuelve la urgencia
     * @return la urengecia
     */
    public String getUrgencia () {
        return urgencia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.62490FDD-4E86-C1F8-B99A-851CBA374068]
    // </editor-fold>
    /**
     * metodo que añade la urgencia
     * @param val es un string que representa la urgencia
     */
    public void setUrgencia (String val) {
        this.urgencia = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1525EEBD-64CD-2855-E9B7-36C6496533CF]
    // </editor-fold>
    /**
     * Metodo que devuelve el valor maximo
     * @return el valor maximo
     */
    public int getValorMax () {
        return valorMax;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E2254C6B-D58F-6FFA-34FD-D416AF2A5356]
    // </editor-fold>
    /**
     * Metodo que añade el valor maximo
     * @param val es un entero que representa el valor maximo
     */
    public void setValorMax (int val) {
        this.valorMax = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.197D1DEB-D60B-3C32-DF79-F86A07B9FBFF]
    // </editor-fold>
    /**
     * Metodo que devuelve el valor medio
     * @return el valor medio
     */
    public int getValorMe () {
        return valorMe;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.56788B02-B81D-FA67-8AA8-8D70C9359B42]
    // </editor-fold>
    /**
     * Metodo que añade el valor medio
     * @param val es un entero que representa un valor medio
     */
    public void setValorMe (int val) {
        this.valorMe = val;
        this.setChanged();
        this.notifyObservers();
    }

    private ArrayList<Integer> lIdentDE = new ArrayList();

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.97F59B5B-DFB5-7CAE-12C5-97FF070BF5D3]
    // </editor-fold>
    /**
     * Metodo que devuelve un dato especifico
     * @param Id
     * @param Descripcion
     * @return un dato especifico
     */
    public DatoEspecifico nuevoDato (int Id, String Descripcion) {
        //// Creo la instancia
        DatoEspecifico auxDE=new DatoEspecifico();
        //// Asigno los valores a los atributos
        auxDE.setId("DAT");
        auxDE.setId_n(Id);
        auxDE.setIdent(auxDE.getId()+String.valueOf(Id));
        auxDE.setDescripcion(Descripcion);
        //// Enlazo el Dato a la lista de RI que tiene el documento
        this.getDatoEspecifico().add(auxDE);
        //persist(auxDE);
        return auxDE;
    }

    /**
     * Metodo que devuelve el destino
     * @return el mDestino
     */
    public ArrayList<String> getMDestino() {
        return mDestino;
    }

    /**
     * Metodo que añade el destino
     * @param mDestino el destino
     */
    public void setMDestino(ArrayList<String> mDestino) {
        this.mDestino = mDestino;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve el origen
     * @return el mOrigen
     */
    public ArrayList<String> getMOrigen() {
        return mOrigen;
    }

    /**
     * Metodo que añade el origen
     * @param mOrigen es el origen
     */
    public void setMOrigen(ArrayList<String> mOrigen) {
        this.mOrigen = mOrigen;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve solo la parte cadena del identificador
     * @return la cadena id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que inserta solo la parte cadena del identificador
     * @param id cadena id a insertar 
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Metodo que devuelve solo la parte número del identificador
     * @return el entero id
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que inserta solo la parte número del identificador
     * @param id_n entero id a insertar
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve el identificador completo
     * @return el identificador
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que inserta el identificador completo
     * @param ident identificador completo a insertar
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object 
     */
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

    /**
     * @return the lIdentDE
     */
    public ArrayList<Integer> getLIdentDE() {
        return lIdentDE;
    }

    /**
     * @param lIdentDE the lIdentDE to set
     */
    public void setLIdentDE(ArrayList<Integer> lIdentDE) {
        this.lIdentDE = lIdentDE;
    }

}

