package modelo;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Observable;
import javax.persistence.*;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.B95A188B-5B4E-9AAB-E7CC-A8DB0F4B6C2C]
// </editor-fold>
/**
 *
 * Clase RequisitoRestriccion, identifica a un <b>Requisito de restriccion</b>.
 */
@Entity
@Table (name="restriction requirement")
public class RequisitoRestriccion extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.39668560-5580-3C81-D236-FCD3D75F3E33]
    // </editor-fold>
    /**
     * Con esta variable guardaremos el nombre del requisito de restriccion
     */
    @Column (name="name RR")
    private String nombre;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.234D8BEE-D8BB-06D2-BA08-455E839317FE]
    // </editor-fold>
    /**
     * Con esta variable guardaremos la descripcion del requisito de restriccion
     */
    @Column (name="description")
    private String descripcion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.C97DC954-03AD-C5C1-B6FF-2C7A00B78FFD]
    // </editor-fold>
    /**
     * Con esta variable guardaremos la importancia del requisito de restriccion
     */
    @Column (name="importance")
    private String importancia;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.A4B2CB87-FD1F-4AF4-D72B-3CF1ED9D659A]
    // </editor-fold>
    /**
     * Con esta variable guardaremos la urgencia del requisito de restriccion
     */
    @Column (name="urgency")
    private String urgencia;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.E20213FA-7FD1-3168-91D4-69E2DB83D713]
    // </editor-fold>
    /**
     * Con esta variable guardaremos la estabilidad del requisito de restriccion
     */
    @Column (name="stability")
    private String estabilidad;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.5790164A-ABE8-DEAD-942C-532FA2834D97]
    // </editor-fold>
    /**
     * Con esta variable guardaremos el estado del requisito de restriccion
     */
    @Column (name="state development")
    private String estado;

    /**
     * Con esta variable guardaremos el array de los destinos del requisito de restriccion
     */
    @OneToMany
    private ArrayList<String> mDestino = new ArrayList();

    /**
     * Con esta variable guardaremos el array de los origenes del requisito de restriccion
     */
    @OneToMany
    private ArrayList<String> mOrigen = new ArrayList();

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.3F38C26C-005E-CF38-C72D-101BBE72F95D]
    // </editor-fold>
    /**
     * Constructor de la clase
     */
    public RequisitoRestriccion () {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.918F52DF-8DF6-92B7-9422-81EC8333ACB8]
    // </editor-fold>
    /**
     * Metodo que devuelve una descripcion
     * return una descricion
     */
    public String getDescripcion () {
        return descripcion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.35722A8B-6296-A2F6-4F69-AB8F6ABE8D3B]
    // </editor-fold>
    /**
     * Metodo que añade una descripcion al requisito de restriccion
     * @param val es un string que representa una descripcion
     */
    public void setDescripcion (String val) {
        this.descripcion = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.7AF79E88-0B04-E870-6D67-A1A89975A3CA]
    // </editor-fold>
    /**
     * Metodo que devuelve la estabilidad del requisito de restriccion
     * @return la estabilidad
     */
    public String getEstabilidad () {
        return estabilidad;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.098F74BE-EF2C-585F-5030-0AB7C299DFC4]
    // </editor-fold>
    /**
     * Metodo que añade la estabilidad del requisito de restriccion
     * @param val es un string que representa la estabilidad
     */
    public void setEstabilidad (String val) {
        this.estabilidad = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.85C703E1-0183-8824-53A5-918E5EB29F30]
    // </editor-fold>
    /**
     * Metodo que añade el estado del requisito de restriccion
     * @return un estado
     */
    public String getEstado () {
        return estado;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F44CEBFD-7829-9E57-2266-9D3A55F22307]
    // </editor-fold>
    /**
     * Metodo que añade un estado del requisito de restriccion
     * @param val es un string que representa un estado
     */
    public void setEstado (String val) {
        this.estado = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E0C19340-F86A-9D19-1906-FE677105D6C9]
    // </editor-fold>
    /**
     * Metodo que devuelve una importancia del requisito de restriccion
     * @return una importacia
     */
    public String getImportancia () {
        return importancia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.71594AF8-D1A2-F656-A8BD-F8FBBB93CA8A]
    // </editor-fold>
    /**
     * Metodo que añade la importancia del requisito de restriccion
     * @param val es un etring que representa la importancia
     */
    public void setImportancia (String val) {
        this.importancia = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.1DE8B124-08BA-A3E7-45D6-DF79B9D07027]
    // </editor-fold>
    /**
     * Metodo que devuelve el nombre del requisito de restriccion
     * @return el nombre
     */
    public String getNombre () {
        return nombre;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.121D887B-D659-00CB-F8C7-11C9370D7045]
    // </editor-fold>
    /**
     * Metodo que añade el nombre
     * @param val es un string que representa el nombre
     */
    public void setNombre (String val) {
        this.nombre = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.B33772C5-F5F6-F5F0-296B-5234B70EA8D8]
    // </editor-fold>
    /**
     * Metodo que devuelve la urgencia del requisito de restriccion
     * @return la urgencia
     */
    public String getUrgencia () {
        return urgencia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.8E77E86F-3799-A722-1F78-8E3A0F3FDA2B]
    // </editor-fold>
    /**
     * Metodo que añade la urgencia al requisito de restriccion
     * @param val es un string que representa la urgencia
     */
    public void setUrgencia (String val) {
        this.urgencia = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve el array del destino
     * @return el destino
     */
    public ArrayList<String> getMDestino() {
        return mDestino;
    }

    /**
     * Metodo que añade un destino
     * @param mDestino es un array de destino
     */
    public void setMDestino(ArrayList<String> mDestino) {
        this.mDestino = mDestino;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve un array de origen
     * @return el origen
     */
    public ArrayList<String> getMOrigen() {
        return mOrigen;
    }

    /**
     * Metodo que añade el origen
     * @param mOrigen es un array de origen
     */
    public void setMOrigen(ArrayList<String> mOrigen) {
        this.mOrigen = mOrigen;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve solo la parte cadena del identificador
     * @return la cadena id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que inserta solo la parte cadena del identificador
     * @param id cadena id a insertar 
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Metodo que devuelve solo la parte número del identificador
     * @return el entero id
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que inserta solo la parte número del identificador
     * @param id_n entero id a insertar
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve el identificador completo
     * @return el identificador
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que inserta el identificador completo
     * @param ident identificador completo a insertar
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object 
     */
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

}

