package modelo;

import java.io.Serializable;
import java.util.Observable;
import javax.persistence.*;

// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.5CA25ADE-3C20-D5D9-9F5A-83A39FEB0506]
// </editor-fold>
/**
 *
 * Clase Reunion, identifica a una <b>Reunion</b>.
 */
@Entity
@Table (name="meeting")
public class Reunion extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.5252889A-9ECB-E77B-F43B-79B65B83C41B]
    // </editor-fold>
    /**
     * Con esta variable guardaremos el nombre de la reunion
     */
    @Column (name="name meeting")
    private String nombre;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.F1597122-84E0-BA80-EB10-72EA794B16CF]
    // </editor-fold>
    /**
     * Con esta variable guardaremos el lugar de la reunion
     */
    @Column (name="place")
    private String lugar;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.03FB128F-20DE-478D-7027-1D94DF89A694]
    // </editor-fold>
    /**
     * Con esta variable guardaremos la fecha de la reunion
     */
    @Column (name="date of meeting")
    private String Fecha;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.033A875D-3E10-5128-4CBF-51CA34D6B66B]
    // </editor-fold>
    /**
     * Con esta variable guardaremos el nombre del asistente de la reunion
     */
    @Column (name="assistant")
    private String asistentes;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.381BAF95-52B7-CCBA-2537-C56E0F0CE3B8]
    // </editor-fold>
    /**
     * Con esta variable guardaremos el string del resultado de la reunion
     */
    @Column (name="result of meeting")
    private String resultados;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.102DE424-9060-4CEE-E909-CF4A107BA7FE]
    // </editor-fold>
    /**
     * Es el constructor de la clase
     */
    public Reunion () {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.A678F9E8-8638-8123-25C8-16DD7D5E89E0]
    // </editor-fold>
    /**
     * Metodo que devuelve una fecha
     * @return una fecha
     */
    public String getFecha () {
        return Fecha;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.68EB1670-91F3-0754-9741-3620697DE282]
    // </editor-fold>
    /**
     * Metodo que añade una fecha
     * @param val es un string que representa una fecha
     */
    public void setFecha (String val) {
        this.Fecha = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.D50B5A5B-3A23-D11D-75AE-39309FD9F375]
    // </editor-fold>
    /**
     * Metodo que devuelve un asistente
     * @return un asistente
     */
    public String getAsistentes () {
        return asistentes;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.6E2674EE-089D-5E89-F8B4-26E48D2CFC60]
    // </editor-fold>
    /**
     * Metodo que añade un asistente
     * @param val es un string que representa un asistente
     */
    public void setAsistentes (String val) {
        this.asistentes = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.8DA3EB4E-ACFB-7ABE-4CB9-6AC2C4059D51]
    // </editor-fold>
    /**
     * Metodo que devuelve un lugar
     * @return un lugar
     */
    public String getLugar () {
        return lugar;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.6FBB3C5D-3979-F5A5-CC2B-3F5E0C4B5F95]
    // </editor-fold>
    /**
     * Metodo que añade un lugar
     * @param val es un string que representa un lugar
     */
    public void setLugar (String val) {
        this.lugar = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.75B34D96-5494-2BA3-5B20-188E0AF46BC5]
    // </editor-fold>
    /**
     * Metodo que devuelve un nombre
     * @return un nombre
     */
    public String getNombre () {
        return nombre;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.36CA88D0-516E-D589-5A68-470146EBCA64]
    // </editor-fold>
    /**
     * Metodo que añade un nombre
     * @param val es un string que representa un nombre
     */
    public void setNombre (String val) {
        this.nombre = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.9AE491CD-2F55-A308-3D21-688FF8073F9C]
    // </editor-fold>
    /**
     * Metodo que devuelve un resultado
     * @return es un resultado
     */
    public String getResultados () {
        return resultados;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.7AFC9F69-6B8A-B006-9C00-384054821926]
    // </editor-fold>
    /**
     * Metodo que añade un resultado
     * @param val es un string que representa un resultado
     */
    public void setResultados (String val) {
        this.resultados = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve solo la parte cadena del identificador
     * @return la cadena id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que inserta solo la parte cadena del identificador
     * @param id cadena id a insertar 
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Metodo que devuelve solo la parte número del identificador
     * @return el entero id
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que inserta solo la parte número del identificador
     * @param id_n entero id a insertar
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve el identificador completo
     * @return el identificador
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que inserta el identificador completo
     * @param ident identificador completo a insertar
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object 
     */
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

}

