package modelo;

import java.io.Serializable;
import java.util.Observable;
import javax.persistence.*;


// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.2E949BB1-A72C-29D1-870B-B9A6D1B82B0C]
// </editor-fold>
/**
 *
 * Clase Seccion, identifica a una <b>Seccion</b>.
 */
@Entity
@Table(name="section ")
public class Seccion extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.D9E1EA74-D276-F457-5887-A9F73983CF31]
    // </editor-fold>
    /**
     * Con esta variable guardaremos el nombre de la seccion
     */
    @Column (name="name section")
    private String nombre;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.8903498C-E79E-ED9C-EB68-6B4A1473BB7E]
    // </editor-fold>
    /**
     * Con esta variable guardaremos el booleano de si es seccion normal
     */
    @Column (name="is normal")
    private boolean seccionNormal;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.B6BB1E0D-6FEF-3CFC-5E03-879C4634FA06]
    // </editor-fold>
    /**
     * Con esta variable guardaremos el booleano si es apendice
     */
    @Column (name="is appendix")
    private boolean seccionApendice;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.15F2EED5-34A1-7001-F842-8036235FD995]
    // </editor-fold>
    /**
     * Con esta variable guardaremos el booleano si es orden
     */
    @Column (name="order")
    private boolean orden;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.162907C6-4DC9-DE28-3E0D-11323C9101D8]
    // </editor-fold>
    /**
     * Con esta variable guardaremos el comentario de la seccion
     */
    @Column (name="comment")
    private String comentarios;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.21CA835F-AEE9-F798-8E57-BB9A1C21FD85]
    // </editor-fold>
    /**
     * Contructor de la clase
     */
    public Seccion () {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.2E59F614-E482-C18D-E7D8-6B8EE203398C]
    // </editor-fold>
    /**
     * Metodo que devuelve el comentario
     * @return el comentario
     */
    public String getComentarios () {
        return comentarios;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.C46830E3-8009-72AF-FE05-8B1AC6D33A62]
    // </editor-fold>
    /**
     * Metodo que añade el comentario
     * @param val es un string que representa un comentario
     */
    public void setComentarios (String val) {
        this.comentarios = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.B2FECA05-7411-A10B-A373-0205611BE404]
    // </editor-fold>
    /**
     * Metodo que devuelve el nombre
     * @return el nombre
     */
    public String getNombre () {
        return nombre;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.DD0597E5-E249-4516-60AA-71A5E1CCC1F2]
    // </editor-fold>
    /**
     * Metodo que añade el nombre a la seccion
     * @param val es un string que representa el nombre
     */
    public void setNombre (String val) {
        this.nombre = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.9520864E-D9B4-8062-19AA-61999B8DC346]
    // </editor-fold>
    /**
     * Metodo que devuelve si es orden o no
     * @return un booleano si es orden o no
     */
    public boolean getOrden () {
        return orden;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.4F736BEC-8DE6-6C34-479C-3FD8978E8731]
    // </editor-fold>
    /**
     * Metodo que añade un booleano de si es orden o no
     * @param val es un booleano que representa si es orden o no
     */
    public void setOrden (boolean val) {
        this.orden = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E9CDED32-C3B3-942D-3820-0144EAB49D51]
    // </editor-fold>
    /**
     * Metodo que devuelve un booleano de apendice, para saber si es o no apendice
     * @return un booleano si es apendice o no
     */
    public boolean getSeccionApendice () {
        return seccionApendice;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.C461F62F-C332-3D14-60E2-BB575165C108]
    // </editor-fold>
    /**
     * Metodo que añade si es apendice o no
     * @param val es un booleano que representa si es un apendice o no
     */
    public void setSeccionApendice (boolean val) {
        this.seccionApendice = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.2495650F-6001-387D-33E7-38C817A84F1E]
    // </editor-fold>
    /**
     * Metodo que devuelve si es seccin normal o no
     * @return un booleano de si es o no una seccion normal
     */
    public boolean getSeccionNormal () {
        return seccionNormal;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.6A342B2D-E01A-1313-7CA1-58105574F866]
    // </editor-fold>
    /**
     * Metodo que añade si es o no una seccion normal
     * @param val es un booleano que reprenseta si es una seccion normal o no
     */
    public void setSeccionNormal (boolean val) {
        this.seccionNormal = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve solo la parte cadena del identificador
     * @return la cadena id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que inserta solo la parte cadena del identificador
     * @param id cadena id a insertar    
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Metodo que devuelve solo la parte número del identificador
     * @return el entero id
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que inserta solo la parte número del identificador
     * @param id_n entero id a insertar
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve el identificador completo
     * @return el identificador
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que inserta el identificador completo
     * @param ident identificador completo a insertar
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object 
     */
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

}

