package modelo;

import java.io.Serializable;
import java.util.Observable;
import javax.persistence.*;

/**
 *
 * Clase Subobjetivo, identifica a un <b>subobjetivo</b>.
 */
@Entity
@Table (name="sub-objective")
public class Subobjetivo extends Observable implements Serializable {

    /**
     * Con esta variable identificamos la parte caracter del identificador
     */
    private String id;
    /**
     * Con esta variable identificamos la parte entera del identificador
     */
    private int id_n;
    /**
     * Con esta variable sabemos el identificador completo
     */
    @Id
    private String ident;
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.345F9F9A-D770-960F-9A43-552A2C1A7540]
    // </editor-fold>
    /**
     * Con esta variable guardaremos el nombre del ssubobjetivo
     */
    @Column (name="name sub-objective")
    private String nombre;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.06C69D63-5230-81E9-28D8-60AC3B50D8AC]
    // </editor-fold>
    /**
     * Con esta variable guardaremos la descripcion del subobjetivo
     */
    @Column (name="description")
    private String descripcion;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.B10E69AF-6F38-BD70-34C4-4BD4A661BE47]
    // </editor-fold>
    /**
     * Con esta variable guardaremos la importacina del subobjetivo
     */
    @Column (name="importance")
    private String importancia;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.56E858D0-67D4-2B00-3FF4-C2A5E90BB6E2]
    // </editor-fold>
    /**
     * Con esta variable guardaremos la urgencia del subobjetivo
     */
    @Column (name="urgency")
    private String urgencia;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.F2D0861D-BDD5-7D0C-A11E-4A5EFC274D4F]
    // </editor-fold>
    /**
     * Con esta variable guardaremos el estado del subobjetivo
     */
    @Column (name="state development")
    private String estado;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.6637298F-84A4-3D64-008A-3AAC5C658FD0]
    // </editor-fold>
    /**
     * Con esta variable guardaremos la estabilidad del subobjetivo
     */
    @Column (name="stability")
    private String estabilidad;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.B67D75EC-F3FD-418A-A777-2F71E7324E9C]
    // </editor-fold>
    /**
     * Constructor de la clase
     */
    public Subobjetivo () {
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.3ACAD184-7E09-B0C8-ACCC-D0B4F5949E7B]
    // </editor-fold>
    /**
     * Metodo que devuelve la descripcion
     * @return el string descripcion
     */
    public String getDescripcion () {
        return descripcion;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.E2426D6B-D7D8-71A6-0320-8EA9EA57BB93]
    // </editor-fold>
    /**
     * Metodo que añade la descricion
     * @param val es un string que representa la descripcion
     */
    public void setDescripcion (String val) {
        this.descripcion = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.075C2257-8272-BCA1-7572-877259687A48]
    // </editor-fold>
    /**
     * Metodo que devuelve la estabilidad
     * @return el string estabilidad
     */
    public String getEstabilidad () {
        return estabilidad;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.0032C77C-7560-3946-F152-7735F97410BB]
    // </editor-fold>
    /**
     * Metodo que añade la estabilidad
     * @param val es un string que representa la estabilidad
     */
    public void setEstabilidad (String val) {
        this.estabilidad = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.413F4D71-E749-776A-1F42-F1572DB218B6]
    // </editor-fold>
    /**
     * Metodo que devuelve el estado
     * @return el estado
     */
    public String getEstado () {
        return estado;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.39F5BDF3-7E64-5CDC-8C5D-B4397E63B9D9]
    // </editor-fold>
    /**
     * Metodo que añade el estado
     * @param val es un string que representa el estado
     */
    public void setEstado (String val) {
        this.estado = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.455808FE-2F61-3CAC-63FA-E2AAFE6CB5CD]
    // </editor-fold>
    /**
     * Metodo que devuelve la importancia
     * @return la importancia
     */
    public String getImportancia () {
        return importancia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.A393AEB6-B628-254C-67A0-C2766FF87EDB]
    // </editor-fold>
    /**
     * Metodo que añade la importancia
     * @param val es un string que representa la importancia
     */
    public void setImportancia (String val) {
        this.importancia = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F35ADAE2-8768-EAE5-DBCF-4EC7265725A9]
    // </editor-fold>
    /**
     * Metodo que devuelve el nombre 
     * @return el nombre
     */
    public String getNombre () {
        return nombre;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.DD5F076D-1354-5FC9-9337-CE5D84F04915]
    // </editor-fold>
    /**
     * Metodo que añade el nombre
     * @param val es un string que representa el nombre
     */
    public void setNombre (String val) {
        this.nombre = val;
        this.setChanged();
        this.notifyObservers();
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.C64A6210-D928-686C-383B-F28649A6036E]
    // </editor-fold>
    /**
     * Metodo que devuelve la urgencia
     * @return la urgencia
     */
    public String getUrgencia () {
        return urgencia;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.0BE80A4D-3A2E-AF2F-8FDF-BE731CF69003]
    // </editor-fold>
    /**
     * Metodo que añade la urgencia 
     * @param val es un string que representa la urgencia
     */
    public void setUrgencia (String val) {
        this.urgencia = val;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que devuelve solo la parte cadena del identificador
     * @return la cadena id
     */
    public String getId() {
        return id;
    }

    /**
     * Metodo que inserta solo la parte cadena del identificador
     * @param id cadena id a insertar
     */
    public void setId(String id) {
        this.id = id;
    }

    /**
     * Metodo que devuelve solo la parte número del identificador
     * @return el entero id
     */
    public int getId_n() {
        return id_n;
    }

    /**
     * Metodo que inserta solo la parte número del identificador
     * @param id_n entero id a insertar
     */
    public void setId_n(int id_n) {
        this.id_n = id_n;
    }

    /**
     * Metodo que devuelve el identificador completo
     * @return el identificador
     */
    public String getIdent() {
        return ident;
    }

    /**
     * Metodo que inserta el identificador completo
     * @param ident identificador completo a insertar
     */
    public void setIdent(String ident) {
        this.ident = ident;
        this.setChanged();
        this.notifyObservers();
    }

    /**
     * Metodo que se encarga de la persistencia
     * @param object 
     */
    public void persist(Object object) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("ArquitecturaPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(object);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

}

